//------------------------------------------------------------
//global variables
var tabbrowser=window.parent.document.getElementById("content");
var lastTime=(new Date()).getTime();   //(nowTime-1970/1/1) in ms
var listengap=3000;                    //define ProgressChange scangap in ms
//------------------------------------------------------------


var webProgressListener = 
{	
	QueryInterface : function(aIID)
	{ 
	        if (aIID.equals(Components.interfaces.nsIWebProgressListener) || 
        	    aIID.equals(Components.interfaces.nsISupportsWeakReference) || 
	            aIID.equals(Components.interfaces.nsISupports)) 
        	        return this; 
        	throw Components.results.NS_NOINTERFACE; 
    	}, 	
	onLocationChange:function(awebProgress,arequest,alocation)
	{
	    //occurs before the url  being loaded
	    //doWebParse();
	    //debug_alert("onLocationChange"+window.location.href);
	},
	onProgressChange:function(awebProgress,arequest,acurSelfProgress,amaxSelfProgress,acurTotalProgress,amaxTotalProgress)
	{
		var curTime=(new Date()).getTime();
		if(curTime-lastTime>=listengap)
		{
			doWebParse();
			lastTime=curTime;
			//debug_alert("onProgressChange");
		}
	},
   	onSecurityChange:function(awebProgress,arequest,astate)
   	{
  	    //debug_alert("onSecurityChange");
  	},
  	onStateChange:function(awebProgress,arequest,aStateFlags,astatus)
  	{
 
  		//debug_alert("onStateChange"+" "+arequest+" "+aStateFlags+" "+astatus);
		if (!((aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) && 
             		(aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW)))
             	{
             		return;
            	}//жϵǰdomǷȫ
		doWebParse();
		//debug_alert("onStateChange");
  	}, 
	onStatusChange:function(awebProgress,arequest,astatus,amessage)
	{
  	    //debug_alert("onStatusChange");
  	}
};

//do addtab for browser
function panelInsertedCb(evt)
{
	try
	{
		 if(evt.relatedNode != tabbrowser.mPanelContainer)
			return;
		var browser = evt.target.childNodes[1];
		browser.addProgressListener(webProgressListener); 
	}
	catch(e)
	{
		debug_alert("panelInsertedCb: "+e);
	}
}

function panelInsertedCb2(evt)
{
	try
	{
		var browser = evt.target.linkedBrowser;
		browser.addProgressListener(webProgressListener); 
	}
	catch(e)
	{
		debug_alert("panelInsertedCb2: "+e);
	}
}

//do deltab for browser
function panelRemovedCb(evt)
{
	try
	{
		if(evt.relatedNode != tabbrowser.mPanelContainer)
			return; 						//Could be anywhere in the DOM (unless bubbling is caught at the interface?)
		var browser = evt.target.childNodes[1];
		browser.removeProgressListener(webProgressListener); 
	}
	catch(e)
	{
		debug_alert("panelRemovedCb"+e);
	}
}

//do deltab for browser
function panelRemovedCb2(evt)
{
	try
	{
		var browser = evt.target.linkedBrowser;
		browser.removeProgressListener(webProgressListener); 
	}
	catch(e)
	{
		debug_alert("panelRemovedCb2"+e);
	}
}

//init globallistener
function hookPanelListeners()
{
	try
	{
		for(var i=0;i<tabbrowser.browsers.length;i++)
		tabbrowser.browsers[i].addProgressListener(webProgressListener);
			
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
		var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
		if(versionChecker.compare(appInfo.version, "2") >= 0)
		{
			tabbrowser.tabContainer.addEventListener("TabOpen", panelInsertedCb2, false);
			tabbrowser.tabContainer.addEventListener("TabClose", panelRemovedCb2, false);
		}
		else
		{
			tabbrowser.mPanelContainer.addEventListener("DOMNodeInserted", panelInsertedCb, false);
			tabbrowser.mPanelContainer.addEventListener("DOMNodeRemoved", panelRemovedCb, false);
		}
		
				
		tabbrowser.tabContainer.addEventListener('select',doWebParse, false);
	}
	catch(e)
	{
		debug_alert("hookPanelListeners: "+e);
	}
}

//unload global listener
function unhookPanelListeners()
{
	try
	{
		var browser0=tabbrowser.browsers[0];
		browser0.removeProgressListener(webProgressListener);
		
		var container=tabbrowser.mPanelContainer;
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
		var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
		if(versionChecker.compare(appInfo.version, "2") >= 0)
		{	
			tabbrowser.tabContainer.removeEventListener("TabOpen", panelInsertedCb2, false);
			tabbrowser.tabContainer.removeEventListener("TabClose", panelRemovedCb2, false);				
		}
		else
		{
			tabbrowser.mPanelContainer.removeEventListener("DOMNodeInserted", panelInsertedCb, false);
			tabbrowser.mPanelContainer.removeEventListener("DOMNodeRemoved", panelRemovedCb, false);	
		}
	
		tabbrowser.tabContainer.removeEventListener('select',doWebParse, false);
	}
	catch(e)
	{
		debug_alert("unhookPanelListeners: "+e);
	}
}
