function dosetSWFProperty()
{
	try
	{
		var fileinfor = window.arguments[0];
		
		document.getElementById("idurleval").value=fileinfor.url;	
		document.getElementById("idsizeval").value=(fileinfor.size=="?"?"Unknown":outputSize(fileinfor.size));
		document.getElementById("iddateval").value=(fileinfor.date=="?"?"Unknown":fileinfor.date);
		
		/*
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
        
		document.getElementById("idstateval").value = hiddenWindow.globalobject.GetStateString(fileinfor.state);				
		*/
		document.getElementById('idurleval').focus();
		
	}
	catch(e)
	{
		debug_alert(e);
	}
		
}
	


function dosetCaptureHistoryProperty()
{
	try
	{
		var fileinfor = window.arguments[0];
		
		document.getElementById("idurleval").value=fileinfor.url;	
		document.getElementById("idsizeval").value=(fileinfor.size=="?"?"Unknown":outputSize(fileinfor.size));
		document.getElementById("iddateval").value=(fileinfor.date=="?"?"Unknown":fileinfor.date);
		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
        
		document.getElementById("idstateval").value = hiddenWindow.globalobject.GetStateString(fileinfor.state);				
		document.getElementById('idurleval').focus();
		
	}
	catch(e)
	{
		debug_alert(e);
	}
		
}
	


function dosetDownloadingProperty()
{
	try
	{
		var fileinfor = window.arguments[0];

		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;

		var name = fileinfor.name;
		if(fileinfor.exname)
			name = name + "." + fileinfor.exname;
			
		var curtime = (new Date()).getTime();
					
		document.getElementById("idnameval").value = name;			
		document.getElementById("idsizeval").value = (fileinfor.size=="?"?"Unknown":outputSize(fileinfor.size));

		document.getElementById("idurleval").value = fileinfor.url;	
		document.getElementById("idcompletedval").value = outputSize(fileinfor.curTotalProgress + fileinfor.beginpos);
		document.getElementById("idstateval").value = hiddenWindow.globalobject.GetStateString(fileinfor.state);		
		
		if(fileinfor.state == hiddenWindow.globalobject.ITEM_STATE_STOP)
		{
			document.getElementById("idelapsedval").value = "";
		}
		else
		{
			document.getElementById("idelapsedval").value = hiddenWindow.globalobject.MillisecondToFormatTime(curtime - fileinfor.beginDownloadTime);
		}
		document.getElementById("idsavepathval").value = fileinfor.savepath;	        
		document.getElementById("idstateval").value = hiddenWindow.globalobject.GetStateString(fileinfor.state);		
		//document.getElementById("iddateval").value = hiddenWindow.globalobject.MillisecondToFormatTime(fileinfor.beginDownloadTime);
		
		document.getElementById('idnameval').focus();
	}
	catch(e)
	{
		debug_alert(e);
	}
		
}	
	
	

function dosetDownloadedProperty()
{
	try
	{
		var fileinfor = window.arguments[0];
		
		var name = fileinfor.name;
		if(fileinfor.exname)
			name = name + "." + fileinfor.exname
		
		document.getElementById("idnameval").value = name;	
		document.getElementById("idsizeval").value=(fileinfor.size=="?"?"Unknown":outputSize(fileinfor.size));
		document.getElementById("idtimecompletedval").value=fileinfor.timecompleted;	
		document.getElementById("idsavepathval").value=fileinfor.savepath;	
		document.getElementById("idurleval").value=fileinfor.url;	

		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
        
		document.getElementById("idstateval").value = hiddenWindow.globalobject.GetStateString(fileinfor.state);		
		
		document.getElementById('idnameval').focus();
		
	}
	catch(e)
	{
		debug_alert(e);
	}
		
}	



function dosetDlgRename()
{
	try
	{
		var fileinfor = window.arguments[0];
		var tempFile = fileinfor.name;
		if(fileinfor.exname.length != 0)
			tempFile += "." + fileinfor.exname;
				
		document.getElementById("idnameval").value=tempFile;	
	}
	catch(e)
	{
		debug_alert(e);
	}
		
}	


function OnRenameAccept()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
         
        var filename = document.getElementById("idnameval").value;	 
        var exName = "";
         
	    if(filename.length == 0)
	    {
		    alert(dynamic_setting_invalidname);
		    return false;
	    }
	    
		if(filename != window.opener.ClearSpecialCharacter(filename))
		{
			alert(dynamic_setting_invalidname);
		    return false;
		}
		

	    if(filename.lastIndexOf(".") != -1)
	    {
	    	exName = filename.substr( filename.lastIndexOf(".") + 1, filename.length-1);
	    	filename = filename.substr( 0, filename.lastIndexOf("."));
	    }

		var strPathName = window.arguments[0].savepath + filename;
		if(exName.length)
		  	strPathName += "." + exName;

		if(filename == window.arguments[0].name && exName == window.arguments[0].exname)
			return true;
		
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		file.QueryInterface(Components.interfaces.nsIFile);
		

		file.initWithPath( strPathName );	
		if(file.exists())
		{
			if(!file.isDirectory())
			{
				var strBuffer = dynamic_message_cannotrename1;
				var re = /\%1/g;
				strBuffer = strBuffer.replace( re, document.getElementById("idnameval").value);    
				alert(strBuffer);
				return false;
			}	
		}	
		
	    try
	    {
			var newfilename = filename;
			if(exName.length)
				newfilename += "." + exName;
			
			var oldfilename = window.arguments[0].savepath + window.arguments[0].name;
			if(window.arguments[0].exname.length)
				oldfilename += "." + window.arguments[0].exname;
			
			file.initWithPath( oldfilename );	
			file.moveTo(null, newfilename);
		}
		catch(e)
		{
			alert(dynamic_message_renameerror);
			return false;
		}
	     
		
		window.arguments[0].name = filename;
		window.arguments[0].exname = exName;
		
		return true;
	}
	catch(e)
	{
		return false;
	}
}

	
	

function GetState(percentComplete)
{	
	if(percentComplete >= 0)
	{
		return "downloading " + percentComplete + "%";;
		//return percentComplete + "%";
	}
	
	return dynamic_filestate_notdownload;
}
	
	
	
function FlvdosetProperty()
{
	try
	{
		var fileinfor=window.opener.curSel[0];
	
		document.getElementById("lblnameval").value=fileinfor.name + "." + fileinfor.filetype;
		document.getElementById("lblsizeval").value=(fileinfor.size=="?"?"Unknown":outputSize(fileinfor.size));
		document.getElementById("lblurleval").value=fileinfor.url;
		
		if(fileinfor.haveSaved)
		{
			document.getElementById("lbStateval").value = dynamic_filestate_download;
		}
		else
		{
			document.getElementById("lbStateval").value = GetState(fileinfor.nState);
			
			if(fileinfor.nState == -1)
			{
				document.getElementById('lbDownload').style.display="none";
				document.getElementById('lbDownloadval').style.display="none";
			}
		}	
		document.getElementById("lbDownloadval").value = fileinfor.strDownloadPathname;
	}
	catch(e)
	{
		debug_alert(e);
	}
	 	
}

	
	
	
	
function dosavepref(){
	
	
	}	
	
//==============================================================
const kbyte=1024;
const kcomma=1e3;
const ten=10;
const one=1;

//format the show of file size with "," 
//format "*,***.*K"
function outputSize(filesize){
	if(filesize=="?"){ 
	     return filesize;
	    }
  else if(filesize>=0){
     var temp=(Math.round(filesize/kbyte*ten))/10;
     if(temp<= 0.1) {
     			return "0.1K";
     }
     else if(temp>0.1 && temp<kcomma)  {
     		return temp+"K";
     }
     else{//process the most complext situation
     	   var part1=Math.floor(temp);
     	   var part2=Math.round(temp%one*10);
     	   var result=(part2==0?"K":"."+part2+"K");
     	   
     	   while(part1>0){
     	   		var part3=part1%kcomma;
     	   		part1=Math.floor(part1/kcomma);
     	   		if(part1==0){
     	   					result=part3+result;
     	   			}
     	   	  else{
     	   	  			var parttemp=part3>=ten*ten?part3:(part3>=ten?"0"+part3:"00"+part3);
     	   	  			result=","+parttemp+result;
     	   	  	} 
     	   	}
     	   return result;    	
     	}
  	}
}	



