//all the  functions about the tree right menu

var bInitUtils = true;

var szTokInvalidNameChars = "%\\/:*?\"<>|\0";	

function OpenSaveDlgObj( inFileName, inExName, inDefPath)
{
	this.inFileName = inFileName;
	this.inExName = inExName;
	
	if(inDefPath == null)
		this.inDefPath = CreateMyDocumentDir();
	else
		this.inDefPath = inDefPath;

	this.resultPath = null;
	this.resultFileName = null;
	this.resultExName = null;
	this.resultPathName = null
	this.resultDefPath = null;
	
}

OpenSaveDlgObj.prototype={

};


function CreateOnlyFile(inBasePath, strFlieName, strEx)
{
	try
	{
	
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
	         	.getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	         	
		var strBasePath = inBasePath;
		
		if(hiddenWindow.globalobject.wvdl_gCurSystem > 1)
		{
			if(strBasePath.substr(strBasePath.length-1,strBasePath.length-1) != "/")
				strBasePath+= "/";
		}
		else
		{
			if(strBasePath.substr(strBasePath.length-1,strBasePath.length-1) != "\\")
				strBasePath+= "\\";
		}
		
		var newPathFileName;
		var newFileName;
	
		for(var i = 0;i < 10000;i++)
		{
		    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			file.QueryInterface(Components.interfaces.nsIFile);
			if(i==0)
			{
				newPathFileName = strBasePath + strFlieName + "." + strEx;
				newFileName = strFlieName;
			}
			else
			{
				newFileName = strFlieName + "("+i+")";
				newPathFileName = strBasePath + strFlieName + "("+i+")" + "." + strEx;	
			}
			file.initWithPath( newPathFileName );
			if(file.exists())
			{
				if(file.isFile())
					continue;
			}
		    file.create(0,0644);
			break;
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
	return newFileName;

}

function createValidDestination(path)
 {
		if (!path) return false;
		var directory = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		
		try {
			directory.initWithPath(path);
			if (directory.exists()) 
				return directory;
		} catch(e) {return false;}
		
		return directory;
}





//get preference
function getPreference(abranch, akey, defvalue)
{
	try{
		var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(abranch);
		var result=null;
         var atype = objectionPrefs.getPrefType(akey);
         //debug_alert(atype);
			switch(atype)
			{   
			     case Components.interfaces.nsIPrefBranch.PREF_BOOL: 	    result=objectionPrefs.getBoolPref(akey);break;
			     case Components.interfaces.nsIPrefBranch.PREF_INT: 	    result=objectionPrefs.getIntPref(akey);break;
			     case Components.interfaces.nsIPrefBranch.PREF_STRING: 	    
			               result=objectionPrefs.getComplexValue(akey, Components.interfaces.nsISupportsString).data;
			               break;
			     default: break;
			}
	}
	catch(e)
	{
		debug_alert(e);
	}
	
	
	if(result == null)
		result = defvalue;
	
	return result;
}


//set preference
function setPreference(abranch,akey, avalue)
{
  var PrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
  var objectionPrefs = PrefService.getBranch(abranch); 
  var type = typeof(avalue);
  try 
  {
  	/*
  	if (type == "number") 
    {
    	avalue = avalue.toString(10);
    }
    */
    if (type == "string") 
    {
      var str = Components.classes["@mozilla.org/supports-string;1"]
                          .createInstance(Components.interfaces.nsISupportsString);
      str.data = avalue;
      objectionPrefs.setComplexValue(akey, Components.interfaces.nsISupportsString, str);
    } 
    else if (type == "boolean") 
    {
      objectionPrefs.setBoolPref(akey, avalue);
    }
    else if (type == "number") 
    {
      objectionPrefs.setIntPref(akey, avalue);
    } 
	else if (type == "object") 
    {
         //objectionPrefs.setIntPref(akey, avalue);
         //do process
    }
  }
  catch(e) 
  {
    debug_alert(e);
  }
}


function MillisecondToFormatTime(millisecond)
{
	var longDateFormat = new Date(millisecond);
	var curhour = longDateFormat.getHours() - 8;
	var curminute = longDateFormat.getMinutes();
	var cursecond = longDateFormat.getSeconds();
 
	var shortformat = (curhour<10?(curhour>0?"0"+curhour:"00"):curhour)+":"+
                 	  (curminute<10?(curminute>0?"0"+curminute:"00"):curminute)+":"+
                 	  (cursecond<10?(cursecond>0?"0"+cursecond:"00"):cursecond);
	return shortformat;
}

  
function GetCurSystemTime()
{
	try
	{
		return shortDateFormat(new Date());
	}
	catch(e)
	{
		debug_alert(e);
	}
}
  
  
function shortDateFormat(longDateFormat)
{

	try
	{	
	  var curmonth=longDateFormat.getMonth()+1;
	  var curdate=longDateFormat.getDate();
	  var curyear=longDateFormat.getYear()+1900;
	  var curhour=longDateFormat.getHours();
	  var curminute=longDateFormat.getMinutes();
	  var cursecond=longDateFormat.getSeconds();
	  
	  var shortformat=(curmonth<10?"0"+curmonth:curmonth)+"/"+
	                  (curdate<10?"0"+curdate:curdate)+"/"+
	                  (curyear<10?"0"+curyear:curyear)+"  "+
	                  (curhour<10?(curhour>0?"0"+curhour:"00"):curhour)+":"+
	                  (curminute<10?(curminute>0?"0"+curminute:"00"):curminute)+":"+
	                  (cursecond<10?(cursecond>0?"0"+cursecond:"00"):cursecond);
	                  
		return shortformat;
	}
	catch(e)
	{
		debug_alert(e);
	}
}
  

//==============================================================
var kbyte=1024;
var kcomma=1e3;
var ten=10;
var one=1;

//format the show of file size with "," 
//format "*,***.*K"
function outputSize(filesize)
{
	if(filesize=="?")
	{ 
	     return filesize;
	}
	
	if(typeof(filesize) != "number")
		return "0.0 Byte";

	if(filesize <  0)		
		return "0.0 Byte";
	
  	else if(filesize>=0)
  	{
  		if(filesize == 0)
  		{
  			return "0.0 Byte";
  		}
	     var temp=(Math.round(filesize/kbyte*ten))/10;
	     
	     
	     if(temp<= 0.1) 
	     {
	     			return "0.1K";
     	 }
     	 else if(temp>0.1 && temp<kcomma)  
     	 {
     	 	if(temp == Math.floor(temp))
     	 		return temp + ".0K"
     		return temp+"K";
     	 }
     	 else
     	 {//process the most complext situation
     	   var part1=Math.floor(temp);
     	   var part2=Math.round(temp%one*10);
     	   var result=(part2==0?".0K":"."+part2+"K");
     	   
     	   while(part1>0){
     	   		var part3=part1%kcomma;
     	   		part1=Math.floor(part1/kcomma);
     	   		if(part1==0){
     	   					result=part3+result;
     	   			}
     	   	  else{
     	   	  			var parttemp=part3>=ten*ten?part3:(part3>=ten?"0"+part3:"00"+part3);
     	   	  			result=","+parttemp+result;
     	   	  	} 
     	   	}
     	   return result;    	
     	}
  	}
}	



function CreateMyDocumentDir()
{	
	try
	{
		strMyDocumentDir = GetMyDocumentDir();
		
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
							file.QueryInterface(Components.interfaces.nsIFile);
							file.initWithPath( strMyDocumentDir );
	
		var bIsNeedCreate = true;
		if(file.exists())
		{
			if(file.isDirectory())
				bIsNeedCreate = false;
		}
		
		if(bIsNeedCreate)
			file.create(1, 777);
			
		return strMyDocumentDir;		

	}
	catch(e)
	{
		debug_alert(e);
	}
}
	
	
	
function GetMyDocumentDir()
{	
	try
	{
		var strMyDocumentDir;	
		var tempObjSothinkWatch;
		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         	.getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
		
        var homeDirectory = Components.classes["@mozilla.org/file/directory_service;1"]
								.getService(Components.interfaces.nsIProperties)
								.get("Home", Components.interfaces.nsIFile);
        
        strMyDocumentDir = homeDirectory.path;
        
		if(wvdl_gCurSystem == 1)
		{
			//strMyDocumentDir += "\\My Documents\\My Videos\\";
			strMyDocumentDir += "\\Downloads\\";
		}
		
		if(hiddenWindow.globalobject.wvdl_gCurSystem > 1)
		{
			if(strMyDocumentDir.substr(strMyDocumentDir.length-1,strMyDocumentDir.length-1) != "/")
			{
				strMyDocumentDir += "/";
			}
		}
		else
		{
			if(strMyDocumentDir.substr(strMyDocumentDir.length-1,strMyDocumentDir.length-1) != "\\")
			{
				strMyDocumentDir += "\\";
			}	
		}
		
		return strMyDocumentDir;
	}
	catch(e)
	{
		debug_alert(e);
	}
	
}



function ClearSpecialCharacter(strBuffer)
{
	try
	{
		strBuffer = unescape(strBuffer);
		strBuffer = ReplaceInvalidCharsInFileName(strBuffer, '_');
		return strBuffer;
	}
	catch(e)
	{
		debug_alert(e);
	}
	
}


function ReplaceInvalidCharsInFileName(szFileName, ch)
{
	try
	{
		var strResult = "";
		
		for(var i = 0;i < szFileName.length;i++)
		{
			var curCh = szFileName.substr(i,1);
			for(var n = 0;n < szTokInvalidNameChars.length;n++)
			{
				if(curCh == szTokInvalidNameChars.substr(n,1))
				{
					curCh = ch;
					break;
				}
			}
			strResult += curCh;
		}
		return strResult;
	}
	catch(e)
	{
		debug_alert(e);
	}
	
}

function OpenSaveDlg( paramobj ) 
{
	try
	{
		
		const nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  		fp.init(window, "Save", nsIFilePicker.modeSave);
  		
  		fp.defaultExtension = "." + paramobj.inExName;
  		fp.defaultString = paramobj.inFileName + "." + paramobj.inExName;

		var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);		 
 	 	fp.displayDirectory = createValidDestination(paramobj.inDefPath);
 	
  		fp.appendFilter(paramobj.inExName + " (*." + paramobj.inExName + ")", "*." + paramobj.inExName);
  		fp.appendFilter("All Files (*.*)", "*.*");
  		
		var rv = fp.show();
		if (rv == nsIFilePicker.returnCancel) 
			return false;
		
		var afile = fp.file;
		
	  	var strBasePath = afile.path.substr(0, afile.path.length - afile.leafName.length);
	  	var filename = afile.leafName.substr( 0, afile.leafName.lastIndexOf("."));
	  	filename = ClearSpecialCharacter(filename);
	  	var exName = afile.leafName.substr( afile.leafName.lastIndexOf(".") + 1, afile.leafName.length-1);

	  	paramobj.resultPath = strBasePath;
	  	paramobj.resultFileName = filename;
	  	paramobj.resultExName = exName;
	  	paramobj.resultPathName = afile.path;
	  	paramobj.resultDefPath = strBasePath;
		
		return true;
	}
	catch(e)	
	{
		debug_alert(e);
	}
}
	
	
	
function dobrowse()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         	.getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		const nsIFilePicker = Components.interfaces.nsIFilePicker;
	  	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	  	fp.init(window, "Choose Directory", nsIFilePicker.modeGetFolder);
	  
	  	
	  	if(hiddenWindow.globalobject.wvdl_gSavePath == null || hiddenWindow.globalobject.wvdl_gSavePath == "")
		{
			hiddenWindow.globalobject.wvdl_gSavePath = GetMyDocumentDir();			
		}
		var basepath = hiddenWindow.globalobject.wvdl_gSavePath;
		fp.displayDirectory = createValidDestination(basepath);
		var rv = fp.show();
		
		if (rv == nsIFilePicker.returnOK) 
		{
			var strDefaultSaveDirictory = fp.file.path;
			if(strDefaultSaveDirictory.substr(strDefaultSaveDirictory.length-1,strDefaultSaveDirictory.length-1) != "\\")
			{
				strDefaultSaveDirictory += "\\";
			}
					
			hiddenWindow.globalobject.wvdl_gSavePath = strDefaultSaveDirictory;
			return fp.file.path;    
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
	return false;
}
	

function MessageBoxObj(message, type)
{
	this.message = message;
	this.type = type;
	this.result = null;
}

MessageBoxObj.prototype={

};	



function getTopWindow()
{
	try
	{
		var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
		var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
		var topWindow = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
	
		if( !topWindow )
		{
			return null;
			//topWindow = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
		}
	
		return topWindow;
	}
	catch(e)
	{
		debug_alert(e);
	}
}

function MessageBoxYesNo(strMessage, type, parentWindow)
{
	var messageparam = new MessageBoxObj(strMessage, type);
	if(parentWindow == null)
	{
		var topWindow = getTopWindow();
		topWindow.openDialog("chrome://webvideodownloader/content/messagebox.xul","_blank","chrome,centerscreen,modal", messageparam);
	}
	else
		parentWindow.openDialog("chrome://webvideodownloader/content/messagebox.xul","_blank","chrome,centerscreen,modal", messageparam);
	return messageparam.result;
}
	
//youtubeվ
function YOUTUBE_getSignature(url){
	var gUrl = "";
	if(url.toLowerCase().indexOf("signature") > -1){
		var urlArray = url.split("&");
		for(var i = 0 ; i < urlArray.length; i++){
			if(urlArray[i].toLowerCase().indexOf("id=") > -1){
				gUrl = urlArray[i];
				break;
			}
		}
		gUrl = gUrl.substring(gUrl.indexOf("=")+1);
		return gUrl;
	}else{
		return url;
	}
}

function YOUTUBE_getURL(url){
	if((/range=\d+-\d+&/).test(url)){
		url = url.replace(/range=\d+-\d+&/,"");
	}
	if((/&range=\d+-\d+/).test(url)){
		url = url.replace(/&range=\d+-\d+/,"");
	}
	return url;
}

function YOUTUBE_getSize(url) {   
	var ioserv = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);   
	var channel = ioserv.newChannel(url, null, null);   
	var stream = channel.open();   
	
	if (channel instanceof Components.interfaces.nsIHttpChannel && channel.responseStatus != 200) {   
	  return "";   
	}  
	
	var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);   
	bstream.setInputStream(stream);   
	
	var contentLength = channel.contentLength;
	bstream.close();
	return contentLength;
}

function YOUTUBE_getSize2(url,callback) {  
	var ajax = Components.classes['@mozilla.org/xmlextras/xmlhttprequest;1'].createInstance(Components.interfaces.nsIXMLHttpRequest);
	ajax.open('HEAD', url, true);
	ajax.setRequestHeader('Cache-Control', 'no-cache');
	ajax.channel.loadFlags |= Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;  
	ajax.url = url;
	
	ajax.onreadystatechange = function(){
		if( this.readyState == 3 ){
			var size = parseInt(this.getResponseHeader("Content-Length"));
			if (this.status == 200) {
				if( size ){
					callback( this.url, size );		
					this.abort();
				}
			}				
		}
		
		if (this.readyState == 4) {
			if (this.status == 200) {
				var size = null;
				try{
					size = parseInt(this.getResponseHeader("Content-Length"));
				}
				catch(ex){}
	
				callback( this.url, size );					
			}
			else{
				callback( this.url, null );
			}
		}
		
	}		
	
	ajax.send( null );
}
//youtubeվ