//-----     global variables

var validateURLs=new Array();
var validateexts=new Array();

var clientID = "HTTP";
var nsICache = Components.interfaces.nsICache;
const timeSpecgap=10000;           //10s per testcache
var loadTimes=0;                   //loadTimes >120 (20min set alive attribute to death)
var timerID=null;


//---------------------------


//parse dom of html web
function webdeveloper_getDocuments(frame, documentList)
{
	try
	{
		    const framesList = frame.frames;
		    documentList.push(frame.document);
			
		    // Loop through the frames
		    for(var i = 0; i < framesList.length; i++)
		    {
		    	if(framesList[i] != null)
			        webdeveloper_getDocuments(framesList[i], documentList);
		    }
		
	    
	}
	catch(e)
	{
		debug_alert(e);
	}
	return documentList;
	
}


//do initialize
function initWeb(){
				while(validateURLs.length) validateURLs.pop();
				while(validateexts.length) validateexts.pop();			
				validateexts.push("swf");
				validateexts.push("asp");
				validateexts.push("jsp");
				validateexts.push("php");
				//validateexts.push("cgi");
				
}


function doWebParse() 
{	
	try
	{	  

	  	initWeb();
		var docs = webdeveloper_getDocuments(window.parent.content, new Array());
	//	debug_alert("Entering function");
		
		for (var j = 0; j < docs.length; j++) {
	 		//debug_alert("Document #" + j);
			var embeds = docs[j].getElementsByTagName("embed");
			if(!embeds)
				continue;
			
			for (var k = 0; k < embeds.length; k++) {               
	
				var url = window.parent.makeURLAbsolute(docs[j].baseURI, embeds[k].src);
				//debug_alert("Embed #" + k + " '" + embeds[k].src + "' => " + url);
				
				
				saveRightURL(validateURLs,url,validateexts);
			}
	
			
			var anchors = docs[j].getElementsByTagName("a");
				
			for (var m = 0; m < anchors.length; m++) 
			{               
	
				var url = window.parent.makeURLAbsolute(docs[j].baseURI, anchors[m].href);
				//debug_alert("anchor #" + m + " '" + anchors[m].href + "' => " + url);
	      		saveRightURL2(validateURLs,url,validateexts);
			}
	
		}
		
		//--------------------------------------		
		//	for(var i=0;i<validateURLs.length;i++){
		//		debug_alert(validateURLs[i]);
		//		}
		//------------------------------------------
				
		if (validateURLs.length == 0) 
		{
			//empty the array when building the gSwfArray each time
		    while(gSwfArray.length)
		    	gSwfArray.pop();
		    //document.getElementById('idSwfTree').view=tree;
		    //document.getElementById('idSwfTree').focus();
		    document.getElementById('idSwfTree').view=null;
			//}catch(e){debug_alert(e);}
			//debug_alert("No Flash movie found on current Page.");
			return;
		}
	
		 //-----------------------------
		 //construct tree with validateURLs
		
	
		 reflectTreeBuild();
		 
		 
		 
	}
	catch(e)
	{
		debug_alert(e);
	}
		 	
}


function testContain(strContainer,strSub){
	var sublen=strSub.length;
	var conlen=strContainer.length;
	if(conlen-sublen<0) return false;
	  for(var i =0;i<=conlen-sublen;i++){
	  	   if(strContainer.substring(i,i+sublen)===strSub) return true;
	  	}
	 return false;
	}



//check embed.src URL
function saveRightURL(URLArray,url,extArray){
try{
var myurl =  Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURL);
myurl.spec = url;
var fileext=myurl.fileExtension;
var match=false;

for(var i=extArray.length-1;i>=0;i--){       
	if(extArray[i]==fileext)
	   {
	   	if(testContain(url,".swf") || (testContain(url,"swf") && testContain(url,fileext+"?"))){
	   	   match=true;
	   	   break;
	     }
	   	}
}

if(!match) return;                        

for(i=URLArray.length-1;i>=0;i--){
//for(var i=0;i<URLArray.length-1;i++){        
			if(URLArray[i]==url) return;
} 
     URLArray.push(url);
     
}
catch(e)
{
	debug_alert(e);
}   
}




//check a.href URL
function saveRightURL2(URLArray,url,extArray){
try{
if(testContain(url,"javascript:")) return;     //filter the jscode in <a>
	
	
var myurl =  Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURL);
myurl.spec = url;
var fileext=myurl.fileExtension;
//a element is so portable,filter is more strict   
   if(fileext=="swf")
     URLArray.push(url);
  }catch(e)
  {
  		debug_alert(e);
  }
}


function reflectTreeBuild()
{

	try
	{
		
		//empty the array when building the gSwfArray each time
		while(gSwfArray.length) gSwfArray.pop();
			
		if(validateURLs.length==0) return;
		
		//debug_alert(validateURLs.length);
		for(var i=validateURLs.length-1;i>=0;i--){
			var path=validateURLs[i];
		
		if(path.substring(0,8)=="file:///")            
		{
		   	try{
	        var file=new File(localfromfilepath(path));
	        //debug_alert(localfromfilepath(path));
	        
	        if(file.exists()){	        	  
	            gSwfArray.push(new window.parent.swfobj(file.leaf(),file.size(),shortDateFormat(new Date(file.dateModified())),false,path,true));
	            
	        }else{
	            gSwfArray.push(new swfobj(path.substring(path.lastIndexOf("/")+1),"?","?",false,path,false));

	        }      
	        }catch(e){debug_alert(e);}
	        
	       // debug_alert("file:///parse done");
			
		}
		
		if(path.substring(0,7)=="http://")            
		{
	     var myurl =  Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURL);
	     myurl.spec =path;
	     var afilename=testContain(myurl.fileName,".swf")?myurl.fileName:myurl.fileName+".swf";
	     gSwfArray.unshift(new swfobj(afilename,"?","?",false,path,null));
	    }
	         
	}//end for
	//debug_alert(gSwfArray.length);
	
		//document.getElementById('idSwfTree').focus();
	
		testcache();
	}
	catch(e)
	{
		debug_alert(e);
	}
}



//change file path to localpath
function localfromfilepath(filepath){
if(filepath.substring(0,8)=="file:///"){
	var temp=filepath.replace("file:///","");
	while(temp.lastIndexOf("/")>0){
	    temp=temp.replace("/","\\");
  }
  while(temp.lastIndexOf("\%")>0){    //all space in path are expressed with "%20"
	    temp=temp.replace("%20"," ");
  }
	return(temp);
	};
	
return null; //͵·null  ......
}





function testcache()
{
	//quick show infor
	try
	{
		refreshcatchtotree();
		
		document.getElementById('idSwfTree').view = swfView;
		//document.getElementById('idSwfTree').focus();
		 
		if(timerID==null)
		{
		       timerID=window.setInterval(refreshcatchtotree,timeSpecgap);
		       loadTimes=0;
		}
		else
		{
			window.clearInterval(timerID);
			timerID=window.setInterval(refreshcatchtotree,timeSpecgap);
			loadTimes=0;
		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}
	//document.getElementById('idSwfTree').focus();
	
}
	

function refreshcatchtotree(){


	try{
		//window.parent.reload();
		
	var cs = Components.classes["@mozilla.org/network/cache-service;1"].getService(Components.interfaces.nsICacheService); 
    var httpCacheSession = cs.createSession("HTTP", nsICache.STORE_ON_DISK, true); 

    for(var ii=gSwfArray.length-1;ii>=0;ii--)
    {
    	try{  
    		    
    	      if(gSwfArray[ii].url==null) continue;
    	      
				    var cdesc = httpCacheSession.openCacheEntry(gSwfArray[ii].url, nsICache.ACCESS_READ, false); 

				    //cdesc.markValid();
				    var file1=cdesc.file;

				    if(file1.exists()){
				   
				       //gSwfArray[ii]["checked"]=false;

				       gSwfArray[ii]["size"]= file1.fileSize;
				       gSwfArray[ii]["date"]=shortDateFormat(new Date(file1.lastModifiedTime));
				       gSwfArray[ii]["alive"] = true;
				    cdesc.close();
				       //debug_alert("exists"+gSwfArray[ii].url); 
				    }
    
      }catch(e){
            //debug_alert(e);
            //debug_alert("catch(e)"+gSwfArray[ii].url);
      }
    }//end for
}catch(e){//debug_alert("outer"+e);
	}
	
	//increase the load times
	loadTimes++;
	//debug_alert(loadTimes);
	if(loadTimes>=120) {
		window.clearInterval(timerID);
		loadTimes=0;
		window.parent.stop();
		for(var ii=gSwfArray.length-1;ii>=0;ii--){
			if(gSwfArray[ii]["alive"] == null)
			 gSwfArray[ii]["alive"]=false;
			}
		}//end if
		
		//refresh treeshow
		//document.getElementById('idSwfTree').focus();
	
	}
	
	