const CI = Components.interfaces;
const CC = Components.classes;

var bInitGlobalObject = true;

var initArrayLoad = false;
var wvdl_gSavePath = null;

var wvdl_gInterceptiontip = null;
var wvdl_gDownloadManageDisplay = false;
var wvdl_gShowBarButton = null;
var wvdl_gRegisterState = null;

var wvdl_gShowStandalonedlg = null;
var wvdl_gDeleteItemAndDeleteFile = null;

var wvdl_gViewSidebar = false;

var wvdl_gShowDownloadingItem = -1;

//0: unknown
//1: WINDOWS
//2: LINUX
//3: MAC
var wvdl_gCurSystem = 0;

var _os = navigator.userAgent.toLowerCase();
if(_os.indexOf("windows") != -1)
{
	wvdl_gCurSystem = 1;
}
else if(_os.indexOf("linux") != -1)
{
	wvdl_gCurSystem = 2;
}
else if(_os.indexOf("mac") != -1)
{
	wvdl_gCurSystem = 3;
}



var wvdl_gInterceptArray = new Array();

var wvdl_gHistoryArray = new Array();
var wvdl_gDownloadingArray = new Array();
var wvdl_gDownloadedArray = new Array();

var wvdl_gWaitDeleteArray = new Array();

const ITEM_STATE_PENDING = 0;
const ITEM_STATE_DOWNLOADING = 1;
const ITEM_STATE_STOP = 2;
const ITEM_STATE_DOWNLOAD = 3;
const ITEM_STATE_ERROR = 4;


const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");





function mediaobj(name, size, url, type)
{
	this.check=true;
	this.name=ClearSpecialCharacter(name);
	this.size=size;
	this.url=url;
	this.nState = -1;
	this.strDownloadPathname = "";
	this.haveSaved = false;
	this.filetype = type;
}

mediaobj.prototype=
{
};



function onload()
{
	try
	{
		//0: unknown
		//1: WINDOWS
		//2: LINUX
		//3: MAC
		
		
		
		
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function LoadParameter()
{
	try
	{	
		wvdl_gInterceptiontip = getPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.Interceptiontip", true);
		//wvdl_gDownloadManageDisplay = getPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.DownloadManageDisplay", false);
		wvdl_gShowBarButton = getPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.ShowBarButton", true);
		wvdl_gSavePath = getPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.SavePath", "");
		
		if(wvdl_gSavePath == "")
		{
			wvdl_gSavePath = GetMyDocumentDir();			
		}
		
		wvdl_gShowStandalonedlg = getPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.ShowStandalonedlg", true);
		
		wvdl_gDeleteItemAndDeleteFile = getPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.DeleteItemAndDeleteFile", true);
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function onunload()
{
	try
	{
	
		ArraySave();
		
		setPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.Interceptiontip", wvdl_gInterceptiontip);
		setPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.DownloadManageDisplay", wvdl_gDownloadManageDisplay);
		setPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.ShowBarButton", wvdl_gShowBarButton);

		setPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.SavePath", wvdl_gSavePath);
		
		setPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.ShowStandalonedlg", wvdl_gShowStandalonedlg);
		setPreference("SothinkWebVideoDownloader", "SothinkWebVideoDownloader.DeleteItemAndDeleteFile", wvdl_gDeleteItemAndDeleteFile);
	}
	catch(e)
	{
		debug_alert(e);
	}
}





function ArraySave()
{
	try
	{

		setPreference("SothinkWebVideoDownloader","WebVideoDownloader.HistoryArray.Length", wvdl_gHistoryArray.length);		
		for(var i=0;i<wvdl_gHistoryArray.length;i++)
		{
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.HistoryArray_"+i+".url", wvdl_gHistoryArray[i].url);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.HistoryArray_"+i+".size", wvdl_gHistoryArray[i].size);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.HistoryArray_"+i+".date", wvdl_gHistoryArray[i].date);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.HistoryArray_"+i+".state", wvdl_gHistoryArray[i].state);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.HistoryArray_"+i+".name", wvdl_gHistoryArray[i].name);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.HistoryArray_"+i+".type", wvdl_gHistoryArray[i].type);
		}
		
		setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadingArray.Length", wvdl_gDownloadingArray.length);		
		for(var i=0;i<wvdl_gDownloadingArray.length;i++)
		{
			if(wvdl_gDownloadingArray[i].state != ITEM_STATE_STOP && wvdl_gDownloadingArray[i].state != ITEM_STATE_ERROR)
			{
				StopDownload(wvdl_gDownloadingArray[i]);
			}			
			
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadingArray_"+i+".url", wvdl_gDownloadingArray[i].url);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadingArray_"+i+".size", wvdl_gDownloadingArray[i].size);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadingArray_"+i+".date", wvdl_gDownloadingArray[i].date);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadingArray_"+i+".state", wvdl_gDownloadingArray[i].state);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadingArray_"+i+".name", wvdl_gDownloadingArray[i].name);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadingArray_"+i+".exname", wvdl_gDownloadingArray[i].exname);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadingArray_"+i+".savepath", wvdl_gDownloadingArray[i].savepath);
			
		}
		
		setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadedArray.Length", wvdl_gDownloadedArray.length);		
		for(var i=0;i<wvdl_gDownloadedArray.length;i++)
		{
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadedArray_"+i+".name", wvdl_gDownloadedArray[i].name);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadedArray_"+i+".exname", wvdl_gDownloadedArray[i].exname);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadedArray_"+i+".size", wvdl_gDownloadedArray[i].size);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadedArray_"+i+".timecompleted", wvdl_gDownloadedArray[i].timecompleted);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadedArray_"+i+".savepath", wvdl_gDownloadedArray[i].savepath);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadedArray_"+i+".state", wvdl_gDownloadedArray[i].state);
			setPreference("SothinkWebVideoDownloader","WebVideoDownloader.DownloadedArray_"+i+".url", wvdl_gDownloadedArray[i].url);
			
		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function GetWVDLwnd()
{	
	try
	{
		var inType = "SWVD:Manager";
		var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
		var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
		var topWindow = windowManagerInterface.getMostRecentWindow(inType);
		
		if (topWindow)
			return topWindow;
		else
			return null;
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function GetStateString(state)
{
	switch(state)
    {   	
		case ITEM_STATE_PENDING:
			return dynamic_downloadstate_notdownload;	 
   		case ITEM_STATE_DOWNLOADING:
   		    return dynamic_downloadstate_downloading;	 
		case ITEM_STATE_STOP:
			return dynamic_downloadstate_stop;	 
		case ITEM_STATE_DOWNLOAD:
			return dynamic_downloadstate_download;	 
		case ITEM_STATE_ERROR:
			return dynamic_downloadstate_error;	 
			
    }
}


function UpdateTreeItem(nWhoTree)
{
	var wnd = GetWVDLwnd();
	if(wnd)
		wnd.UpdateTreeItem(nWhoTree);
}

function UpdateView(index)
{
	var wnd = GetWVDLwnd();
	if(wnd)
		wnd.UpdateView(index);
}


//-----------------------------------------------------
//historyobj
function wvdl_historyobj(url, size, date, state, name, type)
{
	this.url=url;
	this.size=size;
	this.date=date;
	this.state = 0;

	this.name = name;
	this.type = type;
}

wvdl_historyobj.prototype={

};


//downloadingobj
function wvdl_downloadingobj(url, size, date, name, exname, savepath, state)
{
	this.url=url;
	this.size=size;
	this.date=date;
	this.state = state;
	this.name = name;
	this.exname = exname;
	this.savepath = savepath;

	
	this.listener = null;
	this.persist = null;
	
	this.beginDownloadTime = null;
	this.lastProgressTime = 0;
	this.lastTotalProgress = 0;
	this.curSelfProgress = 0;
	this.maxSelfProgress = 0;
	this.curTotalProgress = 0;
	this.maxTotalProgress = 0;
	this.speed = 0;
	this.timeleft = null;
	this.nsILocalFile = null;
	this.nsILocalTempFile = null;
	this.beginpos = 0;
	this.nConnectAgain = 0;

}

wvdl_downloadingobj.prototype={

};



//downloadedobj
function wvdl_downloadedobj(name, exname, size, timecompleted, savepath, state, url)
{
	this.name = name;
	this.exname = exname;
	this.size = size;
	this.timecompleted = timecompleted;
	this.savepath = savepath;
	this.state = state;
	this.url = url;
	
}

wvdl_downloadedobj.prototype={

};



var wvdl_historyView = 
{
    //rowCount : wvdl_gHistoryArray.length,
    selection: null,

    getCellText : function(row,column)
    {	
		try
		{	
        	var column1=column;                 
        	if(typeof(column)=="object")
        	{       
    	    	column1=column.id;  
    	   	}

		    switch(column1)
		    {   	
				case "capturehistory_url":
    				 return wvdl_gHistoryArray[row].url;	 
	    		case "capturehistory_size":
	    		     return outputSize(wvdl_gHistoryArray[row].size); 
				case "capturehistory_capturedate":
					return wvdl_gHistoryArray[row].date;
				/*	 						    		     
				case "capturehistory_status":
					return GetStateString(wvdl_gHistoryArray[row].state);
				*/
		     }
		}
		catch(e)
		{
			debug_alert(e);
		}
		return "";
	},
	    
	getImageSrc: function(idx, column)
	{   
	    try
	    {
		    var column1=column;               
	        if(typeof(column)=="object")
	        {       
	    	    column1=column.id;  
			}

			if(wvdl_gHistoryArray[idx].url==null)
				return "";
	
			if(column1=="capturehistory_url")
   		  	{  		  	   
				return "chrome://webvideodownloader/skin/state_clock.png";
			}
		}
		catch(e)
		{
			debug_alert(e);
		}
	    return "";
	},



    setTree: function(treebox){ this.treebox = treebox; },
    getRowProperties: function(row,props){},
    getCellProperties: function(row,col,props){},
    getColumnProperties: function(colid,col,props){},	
    get rowCount() { return wvdl_gHistoryArray.length; },

	isContainer: function(idx)         { return false; },
	isContainerOpen: function(idx)     { return false; },
	isContainerEmpty: function(idx)    { return false; },
	isSeparator: function(idx)         { return false; },
	isSorted: function()               { return false; }

	 
};




var wvdl_downloadingView = 
{
    //rowCount : wvdl_gDownloadingArray.length,
    selection: null,

    getCellText : function(row,column)
    {	
		try
		{	
        	var column1=column;                 
        	if(typeof(column)=="object")
        	{       
    	    	column1=column.id;  
    	   	}

			
			var curtime = (new Date()).getTime();
		    switch(column1)
		    {
			    case "downloading_name":
					 if(wvdl_gDownloadingArray[row].exname.length)
	    				 return wvdl_gDownloadingArray[row].name + "." + wvdl_gDownloadingArray[row].exname;	 
	    			 else
	    			 	return wvdl_gDownloadingArray[row].name;	 
    			case "downloading_size":
    				 if(wvdl_gDownloadingArray[row].listener == null)
	    				 return outputSize(wvdl_gDownloadingArray[row].size);	 
    				 if(wvdl_gDownloadingArray[row].size < wvdl_gDownloadingArray[row].beginpos + wvdl_gDownloadingArray[row].listener.ItemInfo.curSelfProgress)
    				 	return "?";
					 return outputSize(wvdl_gDownloadingArray[row].size);	 
    			case "downloading_completed":
    				if(wvdl_gDownloadingArray[row].listener == null)
    				{
    					return outputSize(wvdl_gDownloadingArray[row].beginpos);
    				}
		    	   	return outputSize(wvdl_gDownloadingArray[row].beginpos + wvdl_gDownloadingArray[row].listener.ItemInfo.curSelfProgress);
				case "downloading_url":
		    	   	return wvdl_gDownloadingArray[row].url;	 
				case "downloading_speed":
				case "downloading_elapsed":
				case "downloading_timeleft":
					if(wvdl_gDownloadingArray[row].listener == null)
    					return "";
					if(wvdl_gDownloadingArray[row].listener.ItemInfo.state == ITEM_STATE_DOWNLOAD || 
						wvdl_gDownloadingArray[row].listener.ItemInfo.state == ITEM_STATE_STOP ||
						wvdl_gDownloadingArray[row].listener.ItemInfo.state == ITEM_STATE_ERROR)
						return "";
				
					if(column1 == "downloading_elapsed")
					{
						if(wvdl_gDownloadingArray[row].beginDownloadTime == null)
							return dynamic_downloadstate_unknown;
						return MillisecondToFormatTime(curtime - wvdl_gDownloadingArray[row].beginDownloadTime);
					}	
										
					if(column1 == "downloading_speed")
					{
						var progress = curtime - wvdl_gDownloadingArray[row].beginDownloadTime;
						if(progress > 5000)
						{
							var speed = (wvdl_gDownloadingArray[row].listener.ItemInfo.curSelfProgress - wvdl_gDownloadingArray[row].listener.ItemInfo.lastTotalProgress) / progress * 1000;	
							wvdl_gDownloadingArray[row].speed = speed;
							return outputSize(wvdl_gDownloadingArray[row].speed) + "/s";
						}
						else
						{
							return "";
						}
					}
					
					if(wvdl_gDownloadingArray[row].size < wvdl_gDownloadingArray[row].beginpos + wvdl_gDownloadingArray[row].listener.ItemInfo.curSelfProgress)
    				 	return "?";
					
					if(column1 == "downloading_timeleft")
					{
						if(wvdl_gDownloadingArray[row].size < wvdl_gDownloadingArray[row].beginpos + wvdl_gDownloadingArray[row].listener.ItemInfo.curSelfProgress)
    				 		return "?";
    				 	
						if(wvdl_gDownloadingArray[row].speed)
						{
							wvdl_gDownloadingArray[row].timeleft = (wvdl_gDownloadingArray[row].listener.ItemInfo.maxTotalProgress - wvdl_gDownloadingArray[row].listener.ItemInfo.curSelfProgress) / wvdl_gDownloadingArray[row].speed * 1000;
							return MillisecondToFormatTime(wvdl_gDownloadingArray[row].timeleft);
						}
						else
							return "";
					}
					
				case "downloading_status": 	
					if(wvdl_gDownloadingArray[row].listener)
						return GetStateString(wvdl_gDownloadingArray[row].listener.ItemInfo.state);
					else
						return GetStateString(wvdl_gDownloadingArray[row].state);
		     }
		}
		catch(e)
		{
			debug_alert(e);
		}
		return "";
	},
	    
	getImageSrc: function(idx, column)
	{   
	    try
	    {
		    var column1=column;               
	        if(typeof(column)=="object")
	        {       
	    	    column1=column.id;  
			}

			if(wvdl_gDownloadingArray[idx]["name"]==null)
				return "";
	
			if(column1=="downloading_name")
   		  	{  	
   		  		if(wvdl_gDownloadingArray[idx].state == ITEM_STATE_ERROR)
					return "chrome://webvideodownloader/skin/state_4.png";
					
   		  		if(wvdl_gDownloadingArray[idx].state == ITEM_STATE_STOP)
					return "chrome://webvideodownloader/skin/state_1.png";

   		  		if(wvdl_gDownloadingArray[idx].state == ITEM_STATE_DOWNLOADING)
					return "chrome://webvideodownloader/skin/state_2.png";
				
				
			}
		}
		catch(e)
		{
			debug_alert(e);
		}
	    return "";
	},
	
	
	getProgressMode: function(row,col)
	{
		try
		{
			if(col.id == "downloading_progress") 
			{
				if(wvdl_gDownloadingArray[row].listener == null)
					return 0;	   
				
				if(wvdl_gDownloadingArray[row].size < wvdl_gDownloadingArray[row].beginpos + wvdl_gDownloadingArray[row].listener.ItemInfo.curSelfProgress)
					return 0;	   
					
				return Components.interfaces.nsITreeView.PROGRESS_NORMAL;
			}
			else 
				return 0;
		}
		catch(e)
		{
			debug_alert(e);
		}
    },
    
    getCellValue: function(row,col)
    {
    	try
    	{
			if (col.id == "downloading_progress") 
			{
				if(wvdl_gDownloadingArray[row].listener == null)
    					return 0;
    			
    			if(wvdl_gDownloadingArray[row].listener.ItemInfo.maxTotalProgress == -1)
					return 0;	   
							   
				var n = (wvdl_gDownloadingArray[row].beginpos + wvdl_gDownloadingArray[row].listener.ItemInfo.curSelfProgress) * 100.0 / wvdl_gDownloadingArray[row].listener.ItemInfo.size;				
				return n;
			}
		}
		catch(e)
		{
			debug_alert(e);
		}
    },
    

    setTree: function(treebox){ this.treebox = treebox; },
    getRowProperties: function(row,props){},
    getCellProperties: function( row, col, props){},
    getColumnProperties: function(colid,col,props){},	
    get rowCount() { return wvdl_gDownloadingArray.length; },

	isContainer: function(idx)         { return false; },
	isContainerOpen: function(idx)     { return false; },
	isContainerEmpty: function(idx)    { return false; },
	isSeparator: function(idx)         { return false; },
	isSorted: function()               { return false; }

	 
};



var wvdl_downloadedView = 
{
    //rowCount : wvdl_gDownloadedArray.length,
    selection: null,

    getCellText : function(row,column)
    {	
		try
		{	
        	var column1=column;                 
        	if(typeof(column)=="object")
        	{       
    	    	column1=column.id;  
    	   	}
		    switch(column1)
		    {
			    case "downloaded_name":
			    	 if(wvdl_gDownloadedArray[row].exname.length)
	    				 return wvdl_gDownloadedArray[row].name + "." + wvdl_gDownloadedArray[row].exname;	 
	    			 else
	    			 	return wvdl_gDownloadedArray[row].name;	 
    			case "downloaded_size":
    				 return outputSize(wvdl_gDownloadedArray[row].size);	 
    			case "downloaded_timecompleted":
    				 return wvdl_gDownloadedArray[row].timecompleted;	 
				case "downloaded_savepath":
    				 return wvdl_gDownloadedArray[row].savepath;	 
				case "downloaded_status":
					return GetStateString(wvdl_gDownloadedArray[row].state);    				 
				case "downloaded_url":
		    	   	return wvdl_gDownloadedArray[row].url;	 	
		     }
		}
		catch(e)
		{
			debug_alert(e);
		}
		return "";
	},
	    
	getImageSrc: function(idx, column)
	{   
	    try
	    {
		    var column1=column;               
	        if(typeof(column)=="object")
	        {       
	    	    column1=column.id;  
			}

			if(wvdl_gDownloadedArray[idx]["name"]==null)
				return "";
	
			if(column1=="downloaded_name")
   		  	{  		  	   
				return "chrome://webvideodownloader/skin/state_3.png";
			}
		}
		catch(e)
		{
			debug_alert(e);
		}
	    return "";
	},
	
	getProgressMode: function(row,col){},
    getCellValue: function(row,col){},

    setTree: function(treebox){ this.treebox = treebox; },
    getRowProperties: function(row,props){},
    getCellProperties: function( row, col, props){},
    getColumnProperties: function(colid,col,props){},	
    get rowCount() { return wvdl_gDownloadedArray.length; },

	isContainer: function(idx)         { return false; },
	isContainerOpen: function(idx)     { return false; },
	isContainerEmpty: function(idx)    { return false; },
	isSeparator: function(idx)         { return false; },
	isSorted: function()               { return false; }

};

const headerCmpKeys = {
	//'etag': true, // must not be modified from 200 to 206: http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html#sec10.2.7
	'last-modified': true, // may get omitted later, but should not change
	'content-encoding': true // must not change, or download will become corrupt.
};

var HTTPResponseHeaderVisitor = function() {
	// sanity check
	if (arguments.length != 1 || !('attributes' in arguments[0])) return;

	var headers = arguments[0];
	// carica da file le informazioni sugli headers
	try	{
		for (x in headerCmpKeys)	{
			// step over all unset stuff
			if (!headers.hasAttribute('header-' + x))
				continue;
			this[x] = headers.getAttribute('header-' + x);
		}
	} 
	catch (e)
	{
		debug_alert(e);
	}
}


HTTPResponseHeaderVisitor.prototype = {
	type : null,
	encoding : null,
	fileName : null,
	dontacceptrange : false,
	contentlength : 0,
	contentrange : 0,
	
	QueryInterface: function(aIID) {
		if (
			aIID.equals(Components.interfaces.nsISupports)
			|| aIID.equals(Components.interfaces.nsIHttpHeaderVisitor)
		) {
			return this;
		}
		throw Components.results.NS_ERROR_NO_INTERFACE;
	},
	visitHeader : function(aHeader, aValue) 
	{
		try {
		
			const header = aHeader.toLowerCase();
			switch (header) {
				case 'content-type':
					this.type = aValue;
				break;
	
				case 'content-encoding':
					this.encoding = aValue;
				break;
	
				case 'accept-ranges':
					this.dontacceptrange = (aValue.toLowerCase().indexOf('none') >= 0);
					//debug_alert("acceptrange = " + aValue.toLowerCase());
				break;
	
				case 'content-length':
					this.contentlength = Number(aValue);
				break;
	
				case 'content-range':
					var dim = aValue.substring(aValue.lastIndexOf('/') + 1, aValue.length);
					if (dim.length>0 && dim.lastIndexOf('*')==-1)
						this.contentlength = Number(dim);
					this.contentrange = aValue.substring( aValue.indexOf(' '), aValue.lastIndexOf('/'));
					//debug_alert(this.contentrange);
				break;
			}
	
			if (header in headerCmpKeys)
				this[header] = aValue;
			
			if ((header == 'content-type' || header == 'content-disposition') && this.fileName == null) {
				// we have to handle headers like "content-disposition: inline; filename='dummy.txt'; title='dummy.txt';"
				var value = aValue.match(/file(name)?=(["']?)([^\2;]+)\2(;.+)?/i);
				if (!value) {
					// workaround for bug #13959
					// attachments on some vbulletin forums send nasty headers like "content-disposition: inline; filename*=utf-8''file.ext" 
					value = aValue.match(/file(name)?\*=(.*)''(.+)/i);
				}
				if (value) this.fileName = value[3].getUsableFileName();
			}
		}
		catch (ex)
		{
			debug_alert(ex);
		}		
	},
	compare : function(vi)	{
		try	{
			v = vi.QueryInterface(Components.interfaces.nsIHttpHeaderVisitor);
		}	catch (ex) {
			return false;
		}
		
		for (x in headerCmpKeys) {
			// se non abbiamo l'informazione pace
			if (!(x in this)) {
				continue;
			// se ce l'abbiamo ma non c'e' nel nuovo chunk, e non si puo'
			} else if (!(x in v)) {
				// if MAY be missing
				if (headerCmpKeys[x]) {
					continue;
				}
				debug_alert(x + " non presente!");
				return false;
			// se ce l'abbiamo in entrambi ma differiscono
			} else if (this[x] != v[x]) {
				debug_alert(x + ": prima:" + v[x] + " ora: " + this[x]);
				return false;
			}
		}
		return true;
	},
	save : function(node) {
		// salva su file le informazioni sugli headers
		for (x in headerCmpKeys) {
			if (!(x in this)) {
				continue;
			}
			node.setAttribute('header-' + x, this[x]);
		}
		node.setAttribute('hasHeaders', true);
	}
};



//-----------------------------------------------------
// Web Video Downloader PersistProgressListener
//-----------------------------------------------------


function WVDLPersistProgressListener(ItemInfo)
{
	this.ItemInfo = ItemInfo;
}


WVDLPersistProgressListener.prototype = {

	// null function
	init: function() {},
	destroy: function() {},
	prompt: function (dialogTitle, text, passwordRealm, savePassword, defaultText, result) {}, 
	promptPassword: function  (dialogTitle, text, passwordRealm, savePassword, pwd) {},
	onLocationChange: function (aWebProgress, aRequest, aLocation) {},
	onStatusChange: function (aWebProgress, aRequest, aStatus, aMessage) {},
	onSecurityChange: function (aWebProgress, aRequest, aState) {},
	
	QueryInterface : function(aIID) {
		if(aIID.equals(Components.interfaces.nsIWebProgressListener2))
		 return this;
		if(aIID.equals(Components.interfaces.nsIAuthPrompt))
		  return this;
		 throw Components.results.NS_OK;
	},
	
	onProgressChange : function ( webProgress, request, curSelfProgress, maxSelfProgress, curTotalProgress, maxTotalProgress) 
	{
		try
		{
			//alert(curSelfProgress + "; " + maxSelfProgress + "; " + curTotalProgress + "; " + maxTotalProgress);
			
			this.ItemInfo.curSelfProgress = curSelfProgress;
			this.ItemInfo.maxSelfProgress = maxSelfProgress;
			this.ItemInfo.curTotalProgress = curTotalProgress;
			this.ItemInfo.maxTotalProgress = maxTotalProgress;
			
		}
		catch(e)
		{
			debug_alert(e);
		}
	},
	

	onProgressChange64 : function ( webProgress, request, curSelfProgress, maxSelfProgress, curTotalProgress, maxTotalProgress) 
	{
		try
		{
			//alert(curSelfProgress + "; " + maxSelfProgress + "; " + curTotalProgress + "; " + maxTotalProgress);
			
			this.ItemInfo.curSelfProgress = curSelfProgress;
			this.ItemInfo.maxSelfProgress = maxSelfProgress;
			this.ItemInfo.curTotalProgress = curTotalProgress;
			this.ItemInfo.maxTotalProgress = maxTotalProgress;
			
		}
		catch(e)
		{
			debug_alert(e);
		}
	},


	onStateChange : function (aWebProgress, aRequest, aStateFlags, aStatus) 
	{
		try
		{
			var nsISupports = Components.interfaces.nsIWebProgressListener;
			
			if (aStateFlags & nsISupports.STATE_START)
			{
				this.ItemInfo.state = ITEM_STATE_DOWNLOADING;
				return 0;
			}

			if (aStateFlags & nsISupports.STATE_STOP)
			{
				if(DownloadStop(aRequest, this.ItemInfo) == 0)
					return 0;
			}
		}
		catch(e)
		{
			debug_alert(e);
		}
	}
};


function DownloadStop(aRequest, ItemInfo)
{
	try
	{
		var chan = aRequest.QueryInterface(Components.interfaces.nsIHttpChannel);
		if(chan instanceof Components.interfaces.nsIHttpChannel)
		{
			try
			{
				var inFile = ItemInfo.nsILocalTempFile;
				if(chan.responseStatus == 200 || chan.responseStatus == 206)
				{
					if(inFile.fileSize != ItemInfo.curTotalProgress)
					{
						ItemInfo.state = ITEM_STATE_ERROR;
						ItemInfo.persist = null;
						ItemInfo.beginpos = 0;
					}
					else
					{
					
						if(ItemInfo.curTotalProgress == ItemInfo.maxTotalProgress)
						{
							ItemInfo.state = ITEM_STATE_DOWNLOAD;
							DownloadingItemToDownloadedItem();
							return 0;
						}
						
						ItemInfo.state = ITEM_STATE_STOP;
						var inStream = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
						inStream.init( inFile, 1, 0, false);
						var inBinaryStream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
						inBinaryStream.setInputStream(inStream);

						var fileOutput = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
						fileOutput.init( ItemInfo.nsILocalFile, 0x02 | 0x08 | 0x10, 0664, 0);

						var writeSucceed =  fileOutput.write(inBinaryStream.readBytes(inFile.fileSize), inFile.fileSize);
						fileOutput.close();
						inStream.close();
					}
					try
					{		
						inFile.remove(false);
					}
					catch(e){}
					return 0;
				}
			

				if(chan.responseStatus >= 400)
				{
					ItemInfo.state = ITEM_STATE_ERROR;
					try
					{		
						inFile.remove(false);
					}
					catch(e){}
					ItemInfo.persist = null;
					ItemInfo.beginpos = 0;

					//ItemInfo.nConnectAgain
					return 0;
				}
			}
			catch(e)
			{
				ItemInfo.persist = null;
				ItemInfo.beginpos = 0;
				ItemInfo.state = ITEM_STATE_ERROR;
				debug_alert(e);
				return 0;
			}
		}		
	}
	catch(e)
	{
		debug_alert(e);
	}
	
	return 1;
}

function GetFileObj(strPathFileName)
{
	try
	{	
		var file = FileFactory(strPathFileName);
		/*
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		file.QueryInterface(Components.interfaces.nsIFile);
		file.initWithPath( strPathFileName );
		*/
		if(file.exists())
		{
			return file;
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
	return null;
}



function getTopWindow()
{
	try
	{
		var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
		var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
		var topWindow = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
	
		if( !topWindow )
		{
			return null;
			//topWindow = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
		}
	
		return topWindow;
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function readWinRegString(hkroot, hkpath, hk) 
{
	try
	{
	    if (!hk) hk = "";
	    var key, ret = null;
	    if ("@mozilla.org/windows-registry-key;1" in CC) {  // Firefox 1.5 or newer
	      key = CC["@mozilla.org/windows-registry-key;1"].createInstance(CI.nsIWindowsRegKey);
	      key.open(key["ROOT_KEY_" + hkroot], hkpath, key.ACCESS_READ);
	      ret = key.readStringValue(hk);
	      key.close();
	    } else {
	      hkroot = hkroot.replace(/^([A-Z])*_(A_Z).*$/, "HK$1$2"); // CURRENT_USER -> HKCU
	      if ("@mozilla.org/winhooks;1" in CC) {	// SeaMonkey or other older non-toolkit application
	        key = CC["@mozilla.org/winhooks;1"].getService(CI.nsIWindowsRegistry);
	      } else if ("@mozilla.org/browser/shell-service;1" in CC) {
	        key = CC["@mozilla.org/browser/shell-service;1"].getService(CI.nsIWindowsShellService)
	          && ("getRegistryEntry" in key);
	      }
	      if (key) key.getRegistryEntry(key[hkroot], hkpath, hk);
	    }
	    return ret;
	}
	catch(e)
	{
		debug_alert(e);
	}
}

function AppConversionTo(param, curWebDocument)
{
	try
	{
		
		var bCallSucceed = false;
		var path = readWinRegString("LOCAL_MACHINE","SOFTWARE\\SourceTec\\Sothink FLV Converter", "Binary Path");

		var exeFile = CC["@mozilla.org/file/local;1"].createInstance(CI.nsILocalFile);
	    exeFile.initWithPath(path);
	    
	    if(exeFile.exists() && !exeFile.isDirectory())
		{
			const proc = CC['@mozilla.org/process/util;1'].createInstance(CI.nsIProcess);
			proc.init(exeFile);
		    
		    var args = [param];
		    proc.run(false, args, args.length, {});
		    
		    bCallSucceed = true;
		}

	    if(!bCallSucceed)
	    {
	    	if(MessageBoxYesNo(dynamic_ifinstallflvconverter, 1))
			{
				var topWindow = getTopWindow();
				var web = topWindow.document.getElementById("content");

				web.selectedTab = web.addTab(dynamic_downloadflvconverter);
				web.getBrowserForTab(web.selectedTab);
			}	
	    }
	    
	}
	catch(e)
	{
		if(MessageBoxYesNo(dynamic_ifinstallflvconverter, 1))
		{
			var topWindow = getTopWindow();
			var web = topWindow.document.getElementById("content");

			web.selectedTab = web.addTab(dynamic_downloadflvconverter);
			web.getBrowserForTab(web.selectedTab);
		}	
		debug_alert(e);
	}
	
}





function AppPlayer(param, curWebDocument)
{
	try
	{
		var bCallSucceed = false;
		var path = readWinRegString("LOCAL_MACHINE","SOFTWARE\\SourceTec\\Sothink FLV Player", "Binary Path");
		
		var exeFile = CC["@mozilla.org/file/local;1"].createInstance(CI.nsILocalFile);
	    exeFile.initWithPath(path);
	    
	    if(exeFile.exists() && !exeFile.isDirectory())
		{
			const proc = CC['@mozilla.org/process/util;1'].createInstance(CI.nsIProcess);
			proc.init(exeFile);
		    
		    var args = [param];
		    proc.run(false, args, args.length, {});
		    
		    bCallSucceed = true;
		}

	    if(!bCallSucceed)
	    {
	    	if(MessageBoxYesNo(dynamic_ifinstallflvplayer, 1))
			{
				var topWindow = getTopWindow();
				var web = topWindow.document.getElementById("content");

				web.selectedTab = web.addTab(dynamic_downloadflvplayer);
				web.getBrowserForTab(web.selectedTab);
			}	
	    }
	    
	}
	catch(e)
	{
		if(MessageBoxYesNo(dynamic_ifinstallflvplayer, 1))
		{
			var topWindow = getTopWindow();
			var web = topWindow.document.getElementById("content");

			web.selectedTab = web.addTab(dynamic_downloadflvplayer);
			web.getBrowserForTab(web.selectedTab);
		}	
		debug_alert(e);
	}
	
}



function UpdateWeb(curItem)
{
	try
	{
		//alert("in UpdateWeb");
		if(curItem == null)
			reutrn ;
		
		if(curItem.browserHandle == null)
			return ;
			
		if(curItem.browserHandle.contentWindow == null)
			reutrn ;
			
		var curWebDocument = curItem.browserHandle.contentWindow.document;
		var objItem = curWebDocument.getElementById("idFileName");
		var strFileName = "";
		 if(curItem.exname.length)
				strFileName = curItem.name + "." + curItem.exname;	 
			else
				strFileName = curItem.name;	 
					 
		if (strFileName.length>dynamic_urllen)
			objItem.textContent = strFileName.substring(0,dynamic_urllen-3,strFileName)+"...";
		else
			objItem.textContent = strFileName; 
	
		objItem = curWebDocument.getElementById("idFileSize");
		objItem.textContent = outputSize(curItem.size);	 
		
		objItem = curWebDocument.getElementById("idFileURL");
		var str = "<a href=\"" + curItem.url + "\" title=\"" + curItem.url + "\">" + curItem.url + "</a>";
		if (curItem.url.length>dynamic_urllen)
			str = "<a href=\"" + curItem.url + "\" title=\"" + curItem.url + "\">" + curItem.url.substring(0,dynamic_urllen-3,curItem.url)+"..." + "</a>";
		
		objItem.innerHTML = str;	 
	
		objItem = curWebDocument.getElementById("idFileCompleted");
		objItem.textContent = outputSize(curItem.size);	 
			
		/*		
		objItem = curWebDocument.getElementById("idFileStatus");
		objItem.textContent = GetStateString(curItem.state);
		*/
	
		var jpgSrc = curWebDocument.getElementById("idFileProgressJPG").getAttribute("src");				
		objItem = curWebDocument.getElementById("idFileProgressImg");
		var nProgress = 100;					
		objItem.innerHTML='<img id="idFileProgressJPG" src="' + jpgSrc + '" width="'+nProgress+'%" height="10" />';	
		
		objItem = curWebDocument.getElementById("idFileProgress");
		objItem.innerHTML=nProgress + '%';	
		
		/*
		objItem = curWebDocument.getElementById("idFileLocation");	
		objItem.textContent = curItem.savepath;
		*/
		
		
		if(wvdl_gCurSystem == 1)
		{
			var divButton = curWebDocument.getElementById("divButton");
			
			var divTip = curWebDocument.getElementById("idButtonFlvConverter");
			divTip.style.display = 'block';
			
			divTip = curWebDocument.getElementById("idButtonFlvPlayer");
			divTip.style.display = 'block';
			
			curItem.bSetClickFunction = true;
			var Button = curWebDocument.getElementById("idButtonFlvPlayer");
			var param = curItem.savepath + curItem.name + "." + curItem.exname;	 
			if(curItem.FunAppPlayer)
			{
				Button.removeEventListener('click', curItem.FunAppPlayer, 0);
				curItem.FunAppPlayer = null;
			}

			curItem.FunAppPlayer = function(){ AppPlayer(param, curWebDocument); };
			Button.addEventListener('click', curItem.FunAppPlayer, 0);			
			
			Button = curWebDocument.getElementById("idButtonFlvConverter");
			var param = curItem.savepath + curItem.name + "." + curItem.exname;			
			if(curItem.FunAppConversionTo)
			{
				Button.removeEventListener('click', curItem.FunAppConversionTo, 0);
				curItem.FunAppConversionTo = null;
			}
			curItem.FunAppConversionTo = function(){ AppConversionTo(param, curWebDocument); };
			Button.addEventListener('click', curItem.FunAppConversionTo, 0);
		
			curItem.browserHandle = null;
		}
	
	}
	catch(e)
	{
		debug_alert(e);
	}	
}



function LoadWeb(url)
{
	try
	{
		for(var i = 0;i < wvdl_gDownloadedArray.length;i++)
		{
			UpdateWeb(wvdl_gDownloadedArray[i]);
		}	
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function ShowWaitWebPage(curItem)
{
	try
	{
		var curWebDocument = curItem.browserHandle.contentWindow.document;
		var objItem = curWebDocument.getElementById("idFileName");
		var strFileName = curItem.name;
					 
		if (strFileName.length>dynamic_urllen)
			objItem.textContent = strFileName.substring(0,dynamic_urllen-3,strFileName)+"...";
		else
			objItem.textContent = strFileName; 
	
		objItem = curWebDocument.getElementById("idFileSize");
		objItem.textContent = outputSize(curItem.size);	 
		
		objItem = curWebDocument.getElementById("idFileURL");
		var str = "<a href=\"" + curItem.url + "\" title=\"" + curItem.url + "\">" + curItem.url + "</a>";
		if (curItem.url.length>dynamic_urllen)
			str = "<a href=\"" + curItem.url + "\" title=\"" + curItem.url + "\">" + curItem.url.substring(0,dynamic_urllen-3,curItem.url)+"..." + "</a>";
		
		objItem.innerHTML = str;	 
	
		objItem = curWebDocument.getElementById("idFileCompleted");
		objItem.textContent = outputSize(curItem.size);	 
			
		
		var jpgSrc = curWebDocument.getElementById("idFileProgressJPG").getAttribute("src");				
		objItem = curWebDocument.getElementById("idFileProgressImg");
		var nProgress = 100;					
		objItem.innerHTML='<img id="idFileProgressJPG" src="' + jpgSrc + '" width="'+nProgress+'%" height="10" />';	
		
		objItem = curWebDocument.getElementById("idFileProgress");
		objItem.innerHTML=nProgress + '%';	
		

/*
		var objSothinkWatch = Components.classes["@Sothink/ObjectsCatcher;1"].createInstance();
		objSothinkWatch = objSothinkWatch.QueryInterface(Components.interfaces.nsICatcher);
		
		if(objSothinkWatch.GetCurSystem() == 1)
		{
			var divButton = curWebDocument.getElementById("divButton");
			
			var divTip = curWebDocument.getElementById("idButtonFlvConverter");
			divTip.style.display = 'block';
			
			divTip = curWebDocument.getElementById("idButtonFlvPlayer");
			divTip.style.display = 'block';
			
			curItem.bSetClickFunction = true;
			var Button = curWebDocument.getElementById("idButtonFlvPlayer");
			var param = curItem.savepath + curItem.name + "." + curItem.exname;	 
			if(curItem.FunAppPlayer)
			{
				Button.removeEventListener('click', curItem.FunAppPlayer, 0);
				curItem.FunAppPlayer = null;
			}

			curItem.FunAppPlayer = function(){ AppPlayer(param, curWebDocument); };
			Button.addEventListener('click', curItem.FunAppPlayer, 0);			
			
			Button = curWebDocument.getElementById("idButtonFlvConverter");
			var param = curItem.savepath + curItem.name + "." + curItem.exname;			
			if(curItem.FunAppConversionTo)
			{
				Button.removeEventListener('click', curItem.FunAppConversionTo, 0);
				curItem.FunAppConversionTo = null;
			}
			curItem.FunAppConversionTo = function(){ AppConversionTo(param, curWebDocument); };
			Button.addEventListener('click', curItem.FunAppConversionTo, 0);
			//idButtondownload
			
			
		}
		*/
	}
	catch(e)
	{
		debug_alert(e);
	}
}




function DownloadingItemToDownloadedItem()
{
	try
	{
		var tempDownloadingArray = new Array();
		var addArray = new Array();
		for(var i = 0;i < wvdl_gDownloadingArray.length;i++)
		{
			if(wvdl_gDownloadingArray[i].state == ITEM_STATE_DOWNLOAD)
			{
				addArray.push(wvdl_gDownloadingArray[i]);
				continue;
			}
			tempDownloadingArray.push(wvdl_gDownloadingArray[i]);
		}	
		wvdl_gDownloadingArray = tempDownloadingArray;
		
		for(var i = 0;i < addArray.length;i++)
		{
			if(addArray[i].size == "?" || addArray[i].size < addArray[i].beginpos + addArray[i].listener.ItemInfo.curSelfProgress)
			{
				addArray[i].size = addArray[i].beginpos + addArray[i].listener.ItemInfo.curSelfProgress;
			}
			
			//////////////////////////////////////////////////////
			try
			{				
				var inFile = addArray[i].nsILocalTempFile;
			
				var inStream = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
				inStream.init( inFile, 1, 0, false);
				var inBinaryStream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
				inBinaryStream.setInputStream(inStream);
			
				var fileOutput = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
				fileOutput.init( addArray[i].nsILocalFile, 0x02 | 0x08 | 0x10, 0664, 0);
			
				var writeSucceed =  fileOutput.write(inBinaryStream.readBytes(inFile.fileSize), inFile.fileSize);
				fileOutput.close();
				inStream.close();
				
				inFile.remove(false);
			}
			catch(e)
			{
				debug_alert(e);
			}
			
			//////////////////////////////////////////////////////
			
			wvdl_gDownloadedArray.unshift(new wvdl_downloadedobj(
				addArray[i].name,
				addArray[i].exname,
				addArray[i].size,
				GetCurSystemTime(),
				addArray[i].savepath,
				ITEM_STATE_DOWNLOAD,
				addArray[i].url));
			
			wvdl_gDownloadedArray[0].webHandle = addArray[i].webHandle;	
			wvdl_gDownloadedArray[0].tabHandle = addArray[i].tabHandle;	
			wvdl_gDownloadedArray[0].browserHandle = addArray[i].browserHandle;	
			wvdl_gDownloadedArray[0].FunAppPlayer = addArray[i].FunAppPlayer;	
			wvdl_gDownloadedArray[0].FunAppConversionTo = addArray[i].FunAppConversionTo;	
			UpdateWeb(wvdl_gDownloadedArray[0]);
		}
		
		UpdateView(2);
		UpdateView(3);
	}
	catch(e)
	{
		debug_alert(e);
	}

}



function StartDownload( gArrayItem )
{
	try
	{
/*
		var cacheKey  = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
		cacheKey.data = gArrayItem.url;
		var urifix  = Components.classes['@mozilla.org/docshell/urifixup;1'].getService(Components.interfaces.nsIURIFixup);
		var uri     = urifix.createFixupURI(gArrayItem.url, 0);
		var hosturi = null;
		if (uri.host.length > 0)
		{
			hosturi = urifix.createFixupURI(uri.host, 0);
		}

*/
		var obj_URI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(gArrayItem.url, null, null);	 
		
		gArrayItem.nsILocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			
		var tempFile = gArrayItem.savepath + gArrayItem.name;
		if(gArrayItem.exname.length != 0)
			tempFile += "." + gArrayItem.exname;
		
		gArrayItem.nsILocalFile.initWithPath(tempFile);
	
		if(gArrayItem.nsILocalFile.exists())
		{
			try
			{
				var fileOutput = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
				fileOutput.init( gArrayItem.nsILocalFile, 0x04 | 0x20, 0664, 0);
				fileOutput.close();
			}
			catch(e)
			{
				gArrayItem.nsILocalFile = null;
				
				var strBuffer = dynamic_error_filecannotdelete1;
				var re = /\%1/g;
				strBuffer = strBuffer.replace( re, tempFile);    
				gArrayItem.state = ITEM_STATE_STOP;
				alert(strBuffer);
				return ;
			}
		}
	
	
		var persist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);
		var nsIWBP = Components.interfaces.nsIWebBrowserPersist;
		//persist.persistFlags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_FROM_CACHE | nsIWBP.PERSIST_FLAGS_NO_CONVERSION; 
		//persist.persistFlags &= ~nsIWBP.PERSIST_FLAGS_FROM_CACHE;
		persist.persistFlags |= nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
		
								
		var pl= new WVDLPersistProgressListener(gArrayItem);
		persist.progressListener = pl;
		
		gArrayItem.listener = pl;
		gArrayItem.persist = persist;
		gArrayItem.beginDownloadTime = (new Date()).getTime();
		
	
		gArrayItem.nsILocalTempFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		
		tempFile = gArrayItem.savepath + gArrayItem.name;
		if(gArrayItem.exname.length != 0)
			tempFile += "." + gArrayItem.exname + ".temp";
		else
			tempFile += ".temp";
			
		gArrayItem.nsILocalTempFile.initWithPath(tempFile);
		persist.saveURI(obj_URI, null, null, null, null, gArrayItem.nsILocalTempFile);		
		gArrayItem.state = ITEM_STATE_DOWNLOADING;
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function StopDownload(gArrayItem)
{
	try
	{
		if(gArrayItem.persist)
			gArrayItem.persist.cancelSave();
		
		gArrayItem.state = ITEM_STATE_STOP;
		
	}
	catch(e)
	{
		debug_alert(e);
	}
	
}



function ContinueDownload(gArrayItem)
{
	try
	{
		if(gArrayItem.persist == null)
		{
			return StartDownload(gArrayItem);
		}
		
		var obj_URI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(gArrayItem.url, null, null);	 
		var persist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);
		
		//persist.persistFlags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE | nsIWBP.PERSIST_FLAGS_NO_CONVERSION;
		//persist.persistFlags &= ~nsIWBP.PERSIST_FLAGS_FROM_CACHE;
		persist.persistFlags |= nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
		
	
		var pl= new WVDLPersistProgressListener(gArrayItem);
		persist.progressListener = pl;
		
		gArrayItem.listener = pl;
		gArrayItem.persist = persist;
		gArrayItem.listener.ItemInfo.speed = 0;
		gArrayItem.beginDownloadTime = (new Date()).getTime();
		gArrayItem.beginpos += gArrayItem.listener.ItemInfo.curSelfProgress;
		
		var header = "Range: bytes=" + gArrayItem.beginpos + "-" + "\r\n";
		gArrayItem.listener.ItemInfo.curSelfProgress = 0;
		persist.saveURI(obj_URI, null, null, null, header, gArrayItem.nsILocalTempFile);		
		gArrayItem.state = ITEM_STATE_DOWNLOADING;
	
		//debug_alert("ContinueDownload" + header);					

	}	
	catch(e)
	{
		debug_alert(e);
	}
}



function DeleteHistoryItem(url)
{
	try
	{	
		var tempArray = new Array();
		for(var i = 0;i < wvdl_gHistoryArray.length;i++)
		{
			if(wvdl_gHistoryArray[i].url == url)
				 continue;
			tempArray.push(wvdl_gHistoryArray[i]);
		}
		wvdl_gHistoryArray = tempArray;
	}
	catch(e)
	{
		debug_alert(e);
	}

}



function deletefile()
{
	try
	{   
		while(wvdl_gWaitDeleteArray.length) 
		{
			var item = wvdl_gWaitDeleteArray.pop();    
			var strPathName = item.savepath + item.name;
			if(item.exname.length !=0)
				strPathName += "." + item.exname;
				
			var inFile = FileFactory(strPathName);		
			if(inFile.exists() && inFile.isFile())
				inFile.remove(false);
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
}

/////////////////////////////////////////////////////////////////////////////////
//
//
//
/////////////////////////////////////////////////////////////////////////////////

/*
function ShowBarButton(state)
{
	try
	{
		wvdl_gShowBarButton = state;    
		
		var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
		var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
		
		var enumerator = windowManagerInterface.getEnumerator("navigator:browser");
		var hiddenAttribute = "true";
		if(state)
		{
			hiddenAttribute = "false";
		}
		
		while(enumerator.hasMoreElements()) 
		{
			var win = enumerator.getNext();
			var mystatusbarpanel = win.document.getElementById( "webvideodownloader-panel2" );
			var ssbar = win.document.getElementById( "webvideodownloader-bar" );	
			ssbar.setAttribute("hidden", hiddenAttribute);
		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}

}
*/



function SetPostData(Url)
{
	try
	{
		var dataString = "url=" + Url;
		const Cc = Components.classes;
		const Ci = Components.interfaces;
		var stringStream = Cc["@mozilla.org/io/string-input-stream;1"].
		                   createInstance(Ci.nsIStringInputStream);
		if ("data" in stringStream)
		  stringStream.data = dataString;
		else
		  stringStream.setData(dataString, dataString.length);
		
		var postData = Cc["@mozilla.org/network/mime-input-stream;1"].
		               createInstance(Ci.nsIMIMEInputStream);
		postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
		postData.addContentLength = true;
		postData.setData(stringStream);

		return postData;
	}
	catch(e)
	{
		debug_alert(e);
	}

}


function encrypt(urlparam)
{
	try
	{
		var obj = new Base64();
 		var En = obj.Encode64(urlparam);
 		
		return En;
	}
	catch(e)
	{
		debug_alert(e);
	}
}
			
			