var idPreview = null;

const UPDATETREEITEM_ALL = 0;
const UPDATETREEITEM_CAPTUREHISTORY = 1;
const UPDATETREEITEM_DOWNLOADING = 2;
const UPDATETREEITEM_DOWNLOADED = 3;

const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");

var timerSetWebProgressID = null;
var curbrowser = null;
var nPercent = 0;
var nItemIndex = 0;
var arrayItemObj = new Array();

var nShowDownloadingItem = -1;



function ShowPlayer(bShow)
{
	document.getElementById("idSplitter1").setAttribute("hidden", !bShow);
	document.getElementById("flashplayerbox").setAttribute("hidden", !bShow);
	
	if(!bShow)
	{
		var flvplayer = document.getElementById("flvplayer");
		var embed = flvplayer.cloneNode("flvplayer");
		
		var strPath = "chrome://webvideodownloader/skin/flvplayer.swf?flv=";
		
		embed.setAttribute("src", strPath);
		
		var height = getPreference("SothinkWebVideoDownloader", "WebVideoDownloader.FlvPalyHeight", 240);
		if(height != null && (height > 0 && height < 2048))
			embed.setAttribute("height", height);
		else
			embed.setAttribute("height", 240);
			
		var aBox = document.getElementById("flashplayerbox");
		aBox.removeChild(flvplayer);
		aBox.appendChild(embed);
	}
}



function ReplaceURL(url)
{
	try
	{
		var topWindow = getTopWindow();
		if(topWindow)
		{
			var web = topWindow.document.getElementById("content");
			web.selectedTab = web.addTab(url, null, null, null);
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
}

function LoadSothinkAdcolumn()
{
	try
	{
		var sothinkAdcolumn = document.getElementById("sothinkAdcolumn");
		for(var n = 0;n < 1000;n++)
		{
			var nIndex = n+1;
			var idAdcolumnItem = "idAdcolumnItem_" + nIndex;
			var _tempobj = sothinkAdcolumn.contentDocument.getElementById(idAdcolumnItem);
			
			if(_tempobj == null)
				break;
			_tempobj.addEventListener('click', new Function("try{var et=document.getElementById('sothinkAdcolumn').contentDocument.getElementById('idAdcolumnItem_"+ nIndex+"');ReplaceURL(et.href);}catch(e){alert(e)}"), 0);
		}				
	}
	catch(e)
	{
		debug_alert(e);
	}
}

function WVDLStartup()
{
	try
	{
		var nClassTreeSelection = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.ClassTreeSelection", 1);		
		var tree = document.getElementById("idClassTree");
		
		/*
		if(nClassTreeSelection == 1)
		{
			document.getElementById("idCaptureHistory").focus();
		}
		else if(nClassTreeSelection == 2)
		{
			document.getElementById("idDownloading").focus();
		}
		else if(nClassTreeSelection == 3)
		{
			document.getElementById("idDownloaded").focus();
		}
		*/
			
			
		var nClassTreeWidth = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.TreeWidth", 320);				
		if(nClassTreeWidth >= 0 && nClassTreeWidth <= 2048)
		{
			tree.setAttribute("width", nClassTreeWidth);
		}
		else
			tree.setAttribute("width", 320);
		
		
		
		
		var width_capturehistory_url = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.CapturehistoryUrl", 400);
		var width_capturehistory_size = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.CapturehistorySize", 80);
		var width_capturehistory_capturedate = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.CapturehistoryCapturedate", 140);
		//var width_capturehistory_status = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.CapturehistoryStatus", 100);
		
		var width_downloading_name = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingName", 140);
		var width_downloading_size = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingSize", 80);
		var width_downloading_completed = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingCompleted", 80);
		var width_downloading_progress = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingProgress", 100);
		var width_downloading_speed = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingSpeed", 80);
		var width_downloading_elapsed = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingElapsed", 80);
		var width_downloading_timeleft = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingTimeleft", 80);
		var width_downloading_status = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingStatus", 80);
		var width_downloading_url = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingUrl", 300);
		
		var width_downloaded_name = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedName", 160);
		var width_downloaded_size = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedSize", 80);
		var width_downloaded_timecompleted = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedTimecompleted", 140);
		var width_downloaded_savepath = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedSavepath", 300);
		var width_downloaded_status = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedStatus", 80);
		var width_downloaded_url = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedUrl", 300);
		
		
		document.getElementById("capturehistory_url").setAttribute("width", width_capturehistory_url);
		document.getElementById("capturehistory_size").setAttribute("width", width_capturehistory_size);
		document.getElementById("capturehistory_capturedate").setAttribute("width", width_capturehistory_capturedate);
		//document.getElementById("capturehistory_status").setAttribute("width", width_capturehistory_status);
		
		document.getElementById("downloading_name").setAttribute("width", width_downloading_name);
		document.getElementById("downloading_size").setAttribute("width", width_downloading_size);
		document.getElementById("downloading_completed").setAttribute("width", width_downloading_completed);
		document.getElementById("downloading_progress").setAttribute("width", width_downloading_progress);
		document.getElementById("downloading_speed").setAttribute("width", width_downloading_speed);
		document.getElementById("downloading_elapsed").setAttribute("width", width_downloading_elapsed);
		document.getElementById("downloading_timeleft").setAttribute("width", width_downloading_timeleft);
		document.getElementById("downloading_status").setAttribute("width", width_downloading_status);
		document.getElementById("downloading_url").setAttribute("width", width_downloading_url);
		
		document.getElementById("downloaded_name").setAttribute("width", width_downloaded_name);
		document.getElementById("downloaded_size").setAttribute("width", width_downloaded_size);
		document.getElementById("downloaded_timecompleted").setAttribute("width", width_downloaded_timecompleted);
		document.getElementById("downloaded_savepath").setAttribute("width", width_downloaded_savepath);
		document.getElementById("downloaded_status").setAttribute("width", width_downloaded_status);
		document.getElementById("downloaded_url").setAttribute("width", width_downloaded_url);
		
		
		//
		var hidden_capturehistory_url = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.CapturehistoryUrl", false);
		var hidden_capturehistory_size = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.CapturehistorySize", false);
		var hidden_capturehistory_capturedate = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.CapturehistoryCapturedate", false);
		//var hidden_capturehistory_status = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.CapturehistoryStatus", false);
		
		var hidden_downloading_name = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingName", false);
		var hidden_downloading_size = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingSize", false);
		var hidden_downloading_completed = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingCompleted", false);
		var hidden_downloading_progress = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingProgress", false);
		var hidden_downloading_speed = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingSpeed", false);
		var hidden_downloading_elapsed = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingElapsed", false);
		var hidden_downloading_timeleft = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingTimeleft", false);
		var hidden_downloading_status = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingStatus", false);
		var hidden_downloading_url = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingUrl", true);
		
		var hidden_downloaded_name = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedName", false);
		var hidden_downloaded_size = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedSize", false);
		var hidden_downloaded_timecompleted = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedTimecompleted", false);
		var hidden_downloaded_savepath = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedSavepath", true);
		var hidden_downloaded_status = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedStatus", false);
		var hidden_downloaded_url = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedUrl", true);
		
		document.getElementById("capturehistory_url").setAttribute("hidden", hidden_capturehistory_url);
		document.getElementById("capturehistory_size").setAttribute("hidden", hidden_capturehistory_size);
		document.getElementById("capturehistory_capturedate").setAttribute("hidden", hidden_capturehistory_capturedate);
		//document.getElementById("capturehistory_status").setAttribute("hidden", hidden_capturehistory_status);
		
		document.getElementById("downloading_name").setAttribute("hidden", hidden_downloading_name);
		document.getElementById("downloading_size").setAttribute("hidden", hidden_downloading_size);
		document.getElementById("downloading_completed").setAttribute("hidden", hidden_downloading_completed);
		document.getElementById("downloading_progress").setAttribute("hidden", hidden_downloading_progress);
		document.getElementById("downloading_speed").setAttribute("hidden", hidden_downloading_speed);
		document.getElementById("downloading_elapsed").setAttribute("hidden", hidden_downloading_elapsed);
		document.getElementById("downloading_timeleft").setAttribute("hidden", hidden_downloading_timeleft);
		document.getElementById("downloading_status").setAttribute("hidden", hidden_downloading_status);
		document.getElementById("downloading_url").setAttribute("hidden", hidden_downloading_url);
		
		document.getElementById("downloaded_name").setAttribute("hidden", hidden_downloaded_name);
		document.getElementById("downloaded_size").setAttribute("hidden", hidden_downloaded_size);
		document.getElementById("downloaded_timecompleted").setAttribute("hidden", hidden_downloaded_timecompleted);
		document.getElementById("downloaded_savepath").setAttribute("hidden", hidden_downloaded_savepath);
		document.getElementById("downloaded_status").setAttribute("hidden", hidden_downloaded_status);
		document.getElementById("downloaded_url").setAttribute("hidden", hidden_downloaded_url);
		
		document.getElementById('idCaptureHistory').addEventListener("dblclick", OnDbClickCaptureHistoryTree, true);
		document.getElementById('idDownloading').addEventListener("dblclick", OnDbClickDownloadingTree, true);
		document.getElementById('idDownloaded').addEventListener("dblclick", OnDbClickDownloadedTree, true);
		
		ShowPlayer(false);
		UpdateView();
		
		if(nClassTreeSelection >= 0 &&  nClassTreeSelection <= 3)
			tree.view.selection.select(nClassTreeSelection);
		else
		{
			nClassTreeSelection = 1;
			tree.view.selection.select(nClassTreeSelection);
		}
		tree.focus();
		
		setInterval(UpdateTreeItemTime, 1500);
		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
		
		if(hiddenWindow.globalobject.wvdl_gShowDownloadingItem != -1)
		{
			ShowDownloadingItem(hiddenWindow.globalobject.wvdl_gShowDownloadingItem);
			hiddenWindow.globalobject.wvdl_gShowDownloadingItem = -1;
		}
		
		var sothinkAdcolumn = document.getElementById("sothinkAdcolumn");			
		sothinkAdcolumn.addEventListener("load", LoadSothinkAdcolumn, true);
		sothinkAdcolumn.loadURI(dynamic_wvdmanagerAdcolumn);
		
	}
	catch(e)
	{
		debug_alert(e);
	}

}


function WVDLShutdown()
{
	try
	{
		var height = document.getElementById("flashplayerbox").getAttribute("height");
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.FlvPalyHeight", height);		
		
		var width = document.getElementById("idSplitter2").boxObject.x;
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.TreeWidth", width+"");		
		
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.ClassTreeSelection", document.getElementById("idClassTree").view.selection.currentIndex);		
		
		
		
		var width_capturehistory_url = document.getElementById("capturehistory_url").getAttribute("width");
		var width_capturehistory_size = document.getElementById("capturehistory_size").getAttribute("width");
		var width_capturehistory_capturedate = document.getElementById("capturehistory_capturedate").getAttribute("width");
		//var width_capturehistory_status = document.getElementById("capturehistory_status").getAttribute("width");
		
		var width_downloading_name = document.getElementById("downloading_name").getAttribute("width");
		var width_downloading_size = document.getElementById("downloading_size").getAttribute("width");
		var width_downloading_completed = document.getElementById("downloading_completed").getAttribute("width");
		var width_downloading_progress = document.getElementById("downloading_progress").getAttribute("width");
		var width_downloading_speed = document.getElementById("downloading_speed").getAttribute("width");
		var width_downloading_elapsed = document.getElementById("downloading_elapsed").getAttribute("width");
		var width_downloading_timeleft = document.getElementById("downloading_timeleft").getAttribute("width");
		var width_downloading_status = document.getElementById("downloading_status").getAttribute("width");
		var width_downloading_url = document.getElementById("downloading_url").getAttribute("width");
		
		var width_downloaded_name = document.getElementById("downloaded_name").getAttribute("width");
		var width_downloaded_size = document.getElementById("downloaded_size").getAttribute("width");
		var width_downloaded_timecompleted = document.getElementById("downloaded_timecompleted").getAttribute("width");
		var width_downloaded_savepath = document.getElementById("downloaded_savepath").getAttribute("width");
		var width_downloaded_status = document.getElementById("downloaded_status").getAttribute("width");
		var width_downloaded_url = document.getElementById("downloaded_url").getAttribute("width");
		
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.CapturehistoryUrl", width_capturehistory_url);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.CapturehistorySize", width_capturehistory_size);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.CapturehistoryCapturedate", width_capturehistory_capturedate);
		//setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.CapturehistoryStatus", width_capturehistory_status);
		
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingName", width_downloading_name);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingSize", width_downloading_size);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingCompleted", width_downloading_completed);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingProgress", width_downloading_progress);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingSpeed", width_downloading_speed);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingElapsed", width_downloading_elapsed);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingTimeleft", width_downloading_timeleft);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingStatus", width_downloading_status);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadingUrl", width_downloading_url);
		
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedName", width_downloaded_name);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedSize", width_downloaded_size);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedTimecompleted", width_downloaded_timecompleted);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedSavepath", width_downloaded_savepath);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedStatus", width_downloaded_status);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.DownloadedUrl", width_downloaded_url);
				



		
		var hidden_capturehistory_url = document.getElementById("capturehistory_url").getAttribute("hidden");
		var hidden_capturehistory_size = document.getElementById("capturehistory_size").getAttribute("hidden");
		var hidden_capturehistory_capturedate = document.getElementById("capturehistory_capturedate").getAttribute("hidden");
		//var hidden_capturehistory_status = document.getElementById("capturehistory_status").getAttribute("hidden");
		
		var hidden_downloading_name = document.getElementById("downloading_name").getAttribute("hidden");
		var hidden_downloading_size = document.getElementById("downloading_size").getAttribute("hidden");
		var hidden_downloading_completed = document.getElementById("downloading_completed").getAttribute("hidden");
		var hidden_downloading_progress = document.getElementById("downloading_progress").getAttribute("hidden");
		var hidden_downloading_speed = document.getElementById("downloading_speed").getAttribute("hidden");
		var hidden_downloading_elapsed = document.getElementById("downloading_elapsed").getAttribute("hidden");
		var hidden_downloading_timeleft = document.getElementById("downloading_timeleft").getAttribute("hidden");
		var hidden_downloading_status = document.getElementById("downloading_status").getAttribute("hidden");
		var hidden_downloading_url = document.getElementById("downloading_url").getAttribute("hidden");
		
		var hidden_downloaded_name = document.getElementById("downloaded_name").getAttribute("hidden");
		var hidden_downloaded_size = document.getElementById("downloaded_size").getAttribute("hidden");
		var hidden_downloaded_timecompleted = document.getElementById("downloaded_timecompleted").getAttribute("hidden");
		var hidden_downloaded_savepath = document.getElementById("downloaded_savepath").getAttribute("hidden");
		var hidden_downloaded_status = document.getElementById("downloaded_status").getAttribute("hidden");
		var hidden_downloaded_url = document.getElementById("downloaded_url").getAttribute("hidden");

		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.CapturehistoryUrl", hidden_capturehistory_url);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.CapturehistorySize", hidden_capturehistory_size);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.CapturehistoryCapturedate", hidden_capturehistory_capturedate);
		//setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.CapturehistoryStatus", hidden_capturehistory_status);
		
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingName", hidden_downloading_name);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingSize", hidden_downloading_size);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingCompleted", hidden_downloading_completed);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingProgress", hidden_downloading_progress);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingSpeed", hidden_downloading_speed);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingElapsed", hidden_downloading_elapsed);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingTimeleft", hidden_downloading_timeleft);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingStatus", hidden_downloading_status);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadingUrl", hidden_downloading_url);
		
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedName", hidden_downloaded_name);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedSize", hidden_downloaded_size);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedTimecompleted", hidden_downloaded_timecompleted);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedSavepath", hidden_downloaded_savepath);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedStatus", hidden_downloaded_status);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.DownloadedUrl", hidden_downloaded_url);
					
	}
	catch(e)
	{
		debug_alert(e);
	}
}


//==============================================================
const CONST_ALLDOWNLOADS = 0;
const CONST_CAPTUREHISTORY = 1;
const CONST_DOWNLOADING = 2;
const CONST_DOWNLOADED = 3;
//==============================================================

function UpdateView(index)
{	
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;

		var count = hiddenWindow.globalobject.wvdl_gHistoryArray.length + hiddenWindow.globalobject.wvdl_gDownloadingArray.length + hiddenWindow.globalobject.wvdl_gDownloadedArray.length;
		//document.getElementById('treecell_AllDownloads').setAttribute("label", dynamic_treecell_alldownloads + " (" + count + ") ");			
		document.getElementById('treecell_CaptureHistory').setAttribute("label", dynamic_treecell_capturehistory + " (" + hiddenWindow.globalobject.wvdl_gHistoryArray.length + ")");			
		document.getElementById('treecell_Downloading').setAttribute("label", dynamic_treecell_downloading + " (" + hiddenWindow.globalobject.wvdl_gDownloadingArray.length + ")");			
		document.getElementById('treecell_Downloaded').setAttribute("label", dynamic_treecell_downloaded + " (" + hiddenWindow.globalobject.wvdl_gDownloadedArray.length + ")");			
	
		if(isSelectClassItme())
		{					
			return ;
		}
	
  
		switch(index)
		{
		case CONST_CAPTUREHISTORY:
			document.getElementById('idCaptureHistory').view = hiddenWindow.globalobject.wvdl_historyView;

			break;
		case CONST_DOWNLOADING:
			document.getElementById('idDownloading').view = hiddenWindow.globalobject.wvdl_downloadingView;

			break;
		case CONST_DOWNLOADED:
			document.getElementById('idDownloaded').view = hiddenWindow.globalobject.wvdl_downloadedView;

			break;
		default:
			document.getElementById('idCaptureHistory').view = hiddenWindow.globalobject.wvdl_historyView;
			document.getElementById('idDownloading').view = hiddenWindow.globalobject.wvdl_downloadingView;
			document.getElementById('idDownloaded').view = hiddenWindow.globalobject.wvdl_downloadedView;

		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function UpdateTreeItemTime()
{
	try
	{
		UpdateTreeItem(UPDATETREEITEM_ALL);	
		UpdateStatusBar();
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function UpdateStatusBar()
{
	try
	{
		var nCount = 0;
		var nSpeed = 0;
		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
         
		for(var i=0;i<hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{
			if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state != hiddenWindow.globalobject.ITEM_STATE_STOP)
			{
				nCount++;
				nSpeed += hiddenWindow.globalobject.wvdl_gDownloadingArray[i].speed;
			}
		}
		
		if(nCount)
		{
			var strText = dynamic_statusBar_text + nCount + "   " + outputSize(nSpeed) + "/s";
			document.getElementById("idStatusBar").value = strText;
		}
		else
		{
			document.getElementById("idStatusBar").value = "";
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
}




function UpdateTreeItem(nWhoTree)
{
	try
	{
		var tree = null;
		switch(nWhoTree)
		{   	
			case UPDATETREEITEM_CAPTUREHISTORY:
					tree = document.getElementById('idCaptureHistory');
   				 break;	 
    		case UPDATETREEITEM_DOWNLOADING:
	    		    tree = document.getElementById('idDownloading');
   				 break;	 
			case UPDATETREEITEM_DOWNLOADED:
					tree = document.getElementById('idDownloaded');
   				 break;	 
   				 
			case UPDATETREEITEM_ALL:
				UpdateTreeItem(UPDATETREEITEM_CAPTUREHISTORY);
				UpdateTreeItem(UPDATETREEITEM_DOWNLOADING);
				UpdateTreeItem(UPDATETREEITEM_DOWNLOADED);
				return 0;	 						    		     
		}
		

		if(tree.treeBoxObject.invalidate)
		{
			tree.treeBoxObject.invalidate();
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function SwitchSelect(index)
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;	

		switch(index)
		{
			case CONST_ALLDOWNLOADS:
				if(document.getElementById("idCaptureHistory").hidden == false)
				{
					document.getElementById('idCaptureHistory').view = null;
				}
				
				if(document.getElementById("idDownloading").hidden == false)
				{
					document.getElementById('idDownloading').view = null;		
				}
				
				if(document.getElementById("idDownloaded").hidden == false)
				{
					document.getElementById('idDownloaded').view = null;
				}
				ShowPlayer(false);
				break;
			case CONST_CAPTUREHISTORY:
				document.getElementById("idCaptureHistory").setAttribute("hidden","false");
				document.getElementById("idDownloading").setAttribute("hidden","true");
				document.getElementById("idDownloaded").setAttribute("hidden","true");
				ShowPlayer(false);
				
				UpdateView(CONST_CAPTUREHISTORY);
				if(hiddenWindow.globalobject.wvdl_gHistoryArray.length > 0)
					document.getElementById("idCaptureHistory").view.selection.select(0);
				break;
			case CONST_DOWNLOADING:
				document.getElementById("idCaptureHistory").setAttribute("hidden","true");
				document.getElementById("idDownloading").setAttribute("hidden","false");
				document.getElementById("idDownloaded").setAttribute("hidden","true");
				ShowPlayer(false);
				
				UpdateView(CONST_DOWNLOADING);
				if(hiddenWindow.globalobject.wvdl_gDownloadingArray.length > 0)
					document.getElementById("idDownloading").view.selection.select(0);
				break;
			case CONST_DOWNLOADED:
				document.getElementById("idCaptureHistory").setAttribute("hidden","true");
				document.getElementById("idDownloading").setAttribute("hidden","true");
				document.getElementById("idDownloaded").setAttribute("hidden","false");
				
				UpdateView(CONST_DOWNLOADED);
				if(hiddenWindow.globalobject.wvdl_gDownloadedArray.length > 0)
				{
					document.getElementById("idDownloaded").view.selection.select(0);
					OnSelectDownloadedTree();
				}

				break;
			default:
				ShowPlayer(false);
		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function OnSelectClassTree()
{
	try
	{
		if(idPreview != null)
		{
			clearTimeout(idPreview);
			idPreview = null;
		}
		
		var start = new Object();
		var end = new Object();
		var tree = document.getElementById("idClassTree");
		var numRanges = tree.view.selection.getRangeCount();
		
		for (var t = 0; t < numRanges; t++)
		{
		  tree.view.selection.getRangeAt(t,start,end);
		  for (var v = start.value; v <= end.value; v++)
		  {
		  	SwitchSelect(v);
		  }
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doCaptureHistorySave()
{
	try
	{	
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idCaptureHistory');
		
		var count = 0;
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gHistoryArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				count++;
			}
		}
		
		if(count < 1) 
			return ;
		
		if(count == 1)
		{
			var index = 0;
			for(var i = 0;i < hiddenWindow.globalobject.wvdl_gHistoryArray.length;i++)
			{
				if(tree.view.selection.isSelected(i))
				{
					index = i;
					break;
				}
			}
						
			var saveitem = hiddenWindow.globalobject.wvdl_gHistoryArray[index];
			var saveparam = new OpenSaveDlgObj( saveitem.name, saveitem.type, hiddenWindow.globalobject.wvdl_gSavePath);
			if(!OpenSaveDlg(saveparam))
				return -1;
			hiddenWindow.globalobject.wvdl_gSavePath = saveparam.resultDefPath;	
			
			for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
			{	
				var downloadingItem = hiddenWindow.globalobject.wvdl_gDownloadingArray[i].savepath + hiddenWindow.globalobject.wvdl_gDownloadingArray[i].name;
				if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].exname)
					downloadingItem += "." + hiddenWindow.globalobject.wvdl_gDownloadingArray[i].exname;
					
				if(saveparam.resultPathName == downloadingItem)
				{
					alert(dynamic_setting_createfileerror);
					return -1;
				}
			}
			
			hiddenWindow.globalobject.wvdl_gDownloadingArray.unshift(new hiddenWindow.globalobject.wvdl_downloadingobj(
			saveitem.url,
			saveitem.size,
			saveitem.date,
			saveparam.resultFileName,
			saveparam.resultExName,
			saveparam.resultPath, 1));
			
			hiddenWindow.globalobject.StartDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[0]);
			hiddenWindow.globalobject.DeleteHistoryItem(saveitem.url);


			var topWindow = getTopWindow();
			if(topWindow)
			{
				var web = topWindow.document.getElementById("content");
				var url = hiddenWindow.globalobject.encrypt(saveitem.url);
				var postData = hiddenWindow.globalobject.SetPostData(url);
				web.selectedTab = web.addTab(dynamic_downloadweburl, null, null, postData);
			
				var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
				var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
				if(versionChecker.compare(appInfo.version, "2.0") >= 0)
				{	
					var ss = Components.classes["@mozilla.org/browser/sessionstore;1"].getService(Components.interfaces.nsISessionStore);
					ss.setTabValue(web.selectedTab, "wvd", "url=" + saveitem.url);		
				}
			
				var newBrowserHandle = web.getBrowserForTab(web.selectedTab);
				hiddenWindow.globalobject.wvdl_gDownloadingArray[0].webHandle = web;
				hiddenWindow.globalobject.wvdl_gDownloadingArray[0].tabHandle = web.selectedTab;
				hiddenWindow.globalobject.wvdl_gDownloadingArray[0].browserHandle = newBrowserHandle;
				newBrowserHandle.addEventListener("load", function() { hiddenWindow.globalobject.LoadWeb(url); }, true);
			}
					
		}
			
		if(count > 1)
		{
			var strResultSavePath = dobrowse();
			
			if(strResultSavePath != false)
			{
				if(hiddenWindow.globalobject.wvdl_gCurSystem > 1)
					strResultSavePath += "/"; 
				else
					strResultSavePath += "\\"; 
					
				
				var tempArray = new Array();
				for(var i = 0;i < hiddenWindow.globalobject.wvdl_gHistoryArray.length;i++)
				{
					if(tree.view.selection.isSelected(i))
					{
						var filename = ClearSpecialCharacter(hiddenWindow.globalobject.wvdl_gHistoryArray[i].name);
						var strResult = CreateOnlyFile(strResultSavePath, filename, hiddenWindow.globalobject.wvdl_gHistoryArray[i].type);
					
						hiddenWindow.globalobject.wvdl_gDownloadingArray.unshift(new hiddenWindow.globalobject.wvdl_downloadingobj(
						hiddenWindow.globalobject.wvdl_gHistoryArray[i].url,
						hiddenWindow.globalobject.wvdl_gHistoryArray[i].size,
						hiddenWindow.globalobject.wvdl_gHistoryArray[i].date,
						strResult,
						hiddenWindow.globalobject.wvdl_gHistoryArray[i].type,
						strResultSavePath, 1));

						var topWindow = getTopWindow();
						if(topWindow)
						{
							var web = topWindow.document.getElementById("content");
							var url = hiddenWindow.globalobject.encrypt(hiddenWindow.globalobject.wvdl_gDownloadingArray[0].url);
							var postData = hiddenWindow.globalobject.SetPostData(url);
							web.selectedTab = web.addTab(dynamic_downloadweburl, null, null, postData);
						
							var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
							var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
							if(versionChecker.compare(appInfo.version, "2.0") >= 0)
							{				
								var ss = Components.classes["@mozilla.org/browser/sessionstore;1"].getService(Components.interfaces.nsISessionStore);
								ss.setTabValue(web.selectedTab, "wvd", "url=" + hiddenWindow.globalobject.wvdl_gDownloadingArray[0].url);		
							}			
						
							var newBrowserHandle = web.getBrowserForTab(web.selectedTab);
							hiddenWindow.globalobject.wvdl_gDownloadingArray[0].webHandle = web;
							hiddenWindow.globalobject.wvdl_gDownloadingArray[0].tabHandle = web.selectedTab;
							hiddenWindow.globalobject.wvdl_gDownloadingArray[0].browserHandle = newBrowserHandle;
							newBrowserHandle.addEventListener("load", function() { hiddenWindow.globalobject.LoadWeb(url); }, true);
						}
							
						tempArray.push(hiddenWindow.globalobject.wvdl_gDownloadingArray[0].url);
						hiddenWindow.globalobject.StartDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[0]);
						
					}
				}
				
				for(var i = 0;i < tempArray.length;i++)
				{
					hiddenWindow.globalobject.DeleteHistoryItem(tempArray[i]);
				}
			}
		}
		
		UpdateView(CONST_CAPTUREHISTORY);		
		UpdateView(CONST_DOWNLOADING);

	}
	catch(e)
	{
		//debug_alert(e);
		debug_alert(e);
	}
	
}


function doCaptureHistorySaveall()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
    	     .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
    
		var strSavePath = dobrowse();
			
		if(strSavePath != false)
		{	    
    	    if(hiddenWindow.globalobject.wvdl_gCurSystem > 1)
				strSavePath += "/"; 
			else
				strSavePath += "\\"; 
			var tempArray = new Array();
			
		
			for(var i = 0;i < hiddenWindow.globalobject.wvdl_gHistoryArray.length;i++)
			{
				var filename = ClearSpecialCharacter(hiddenWindow.globalobject.wvdl_gHistoryArray[i].name);
				var strResult = CreateOnlyFile(strSavePath, filename, hiddenWindow.globalobject.wvdl_gHistoryArray[i].type);
				
				hiddenWindow.globalobject.wvdl_gDownloadingArray.unshift(new hiddenWindow.globalobject.wvdl_downloadingobj(
				hiddenWindow.globalobject.wvdl_gHistoryArray[i].url,
				hiddenWindow.globalobject.wvdl_gHistoryArray[i].size,
				hiddenWindow.globalobject.wvdl_gHistoryArray[i].date,
				strResult,
				hiddenWindow.globalobject.wvdl_gHistoryArray[i].type,
				strSavePath, 1));
				
				var topWindow = getTopWindow();
				var web = topWindow.document.getElementById("content");
				
				var url = hiddenWindow.globalobject.encrypt(hiddenWindow.globalobject.wvdl_gDownloadingArray[0].url);
				var postData = hiddenWindow.globalobject.SetPostData(url);
				web.selectedTab = web.addTab(dynamic_downloadweburl, null, null, postData);
				
				var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
				var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
				if(versionChecker.compare(appInfo.version, "2.0") >= 0)
				{		
					var ss = Components.classes["@mozilla.org/browser/sessionstore;1"].getService(Components.interfaces.nsISessionStore);
					ss.setTabValue(web.selectedTab, "wvd", "url=" + hiddenWindow.globalobject.wvdl_gDownloadingArray[0].url);		
				}
								
				var newBrowserHandle = web.getBrowserForTab(web.selectedTab);
				hiddenWindow.globalobject.wvdl_gDownloadingArray[0].webHandle = web;
				hiddenWindow.globalobject.wvdl_gDownloadingArray[0].tabHandle = web.selectedTab;
				hiddenWindow.globalobject.wvdl_gDownloadingArray[0].browserHandle = newBrowserHandle;
				newBrowserHandle.addEventListener("load", function() { hiddenWindow.globalobject.LoadWeb(url); }, true);
								
				tempArray.push(hiddenWindow.globalobject.wvdl_gDownloadingArray[0].url);				
				hiddenWindow.globalobject.StartDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[0]);	

			}
			
			for(var i = 0;i < tempArray.length;i++)
			{
				hiddenWindow.globalobject.DeleteHistoryItem(tempArray[i]);
			}
			
			UpdateView(CONST_CAPTUREHISTORY);		
			UpdateView(CONST_DOWNLOADING);
		}
  		
	}
	catch(e)
	{
		debug_alert(e);
	}
	
	
}


function doCaptureHistoryDelete()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idCaptureHistory');
		
		var tempArray = new Array();
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gHistoryArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
				 continue;
			tempArray.push(hiddenWindow.globalobject.wvdl_gHistoryArray[i]);
		}
		
		hiddenWindow.globalobject.wvdl_gHistoryArray = tempArray;
		UpdateView(CONST_CAPTUREHISTORY);
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doCaptureHistoryDeleteall()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idCaptureHistory');
		
		while(hiddenWindow.globalobject.wvdl_gHistoryArray.length)	
		{
			hiddenWindow.globalobject.wvdl_gHistoryArray.pop();    
		}
		UpdateView(CONST_CAPTUREHISTORY);

	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doCaptureHistoryProperties()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idCaptureHistory');
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gHistoryArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				window.openDialog("chrome://webvideodownloader/content/capturehistoryproperty.xul","_blank","chrome,resizable,width=500,height=200,centerscreen",hiddenWindow.globalobject.wvdl_gHistoryArray[i]);
			}
		}	
	}
	catch(e)
	{
		debug_alert(e);
	}	
		
}


//Downloading cmd
function doDownloadingStart()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloading');
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state == hiddenWindow.globalobject.ITEM_STATE_STOP || hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state == hiddenWindow.globalobject.ITEM_STATE_ERROR)
				{
					hiddenWindow.globalobject.ContinueDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
				}
			}
		}
		UpdateView(CONST_DOWNLOADING);
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doDownloadingStop()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloading');
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state == hiddenWindow.globalobject.ITEM_STATE_DOWNLOADING)
				{
					hiddenWindow.globalobject.StopDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
				}
				continue;
			}
		}
		UpdateView(CONST_DOWNLOADING);
	
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doDownloadingStartall()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloading');
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{	
			if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state == hiddenWindow.globalobject.ITEM_STATE_STOP || hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state == hiddenWindow.globalobject.ITEM_STATE_ERROR)
			{
				hiddenWindow.globalobject.ContinueDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
			}
		}
		
		UpdateView(CONST_DOWNLOADING);
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doDownloadingStopall()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloading');
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{	
			if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state == hiddenWindow.globalobject.ITEM_STATE_DOWNLOADING)
			{
				hiddenWindow.globalobject.StopDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);				
			}
		}
		UpdateView(CONST_DOWNLOADING);
	
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function DeleteTab(web, tab)
{
	try
	{	
		if(web)
			web.removeTab(tab); 
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function doDownloadingDelete()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloading');
		
		var tempArray = new Array();
		var bDelete = false;
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				if(bDelete == false)
				{
					if(!IsSureDelete())
						return ;	
				}
			
				if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state != hiddenWindow.globalobject.ITEM_STATE_STOP && hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state != hiddenWindow.globalobject.ITEM_STATE_ERROR)
					hiddenWindow.globalobject.StopDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
					
				bDelete = true;
				if(hiddenWindow.globalobject.wvdl_gDeleteItemAndDeleteFile)
					hiddenWindow.globalobject.wvdl_gWaitDeleteArray.push(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
				
				DeleteTab(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].webHandle, hiddenWindow.globalobject.wvdl_gDownloadingArray[i].tabHandle);
				continue;
			}
			tempArray.push(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
		}
		
		if(bDelete)
		{
			setTimeout( hiddenWindow.globalobject.deletefile, 1000);	
		}
		
		hiddenWindow.globalobject.wvdl_gDownloadingArray = tempArray;
		UpdateView(CONST_DOWNLOADING);
	
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doDownloadingDeleteall()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloading');
		
		while(hiddenWindow.globalobject.wvdl_gDownloadingArray.length)	
		{
			if(hiddenWindow.globalobject.wvdl_gDownloadingArray[0].persist)
				hiddenWindow.globalobject.wvdl_gDownloadingArray[0].persist.cancelSave();
			hiddenWindow.globalobject.wvdl_gDownloadingArray[0].state = hiddenWindow.globalobject.ITEM_STATE_STOP;
			hiddenWindow.globalobject.wvdl_gDownloadingArray.pop();    
		}
		UpdateView(CONST_DOWNLOADING);
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function doDownloadingProperties()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloading');
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				window.openDialog("chrome://webvideodownloader/content/downloadingproperty.xul","_blank","chrome,resizable,width=500,height=200,centerscreen",hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
			}
		}	
	}
	catch(e)
	{
		debug_alert(e);
	}	
		
}



function IsSureObj()
{
	this.result = false;
}

IsSureObj.prototype={

};	

function IsSureDelete()
{
	try
	{
		var IsSure = new IsSureObj();
		window.openDialog("chrome://webvideodownloader/content/warndeletedlg.xul","_blank","chrome,modal,centerscreen", IsSure);					
		return IsSure.result;
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doDownloadedDelete()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloaded');
		
		var tempArray = new Array();
		var bDelete = false;
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadedArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				if(!bDelete)
				{
					if(!IsSureDelete())
						return ;
					
					ShowPlayer(false);
				}
				bDelete = true;
				if(hiddenWindow.globalobject.wvdl_gDeleteItemAndDeleteFile)
				{
					hiddenWindow.globalobject.wvdl_gWaitDeleteArray.push(hiddenWindow.globalobject.wvdl_gDownloadedArray[i]);
				}
				continue;
			}
			tempArray.push(hiddenWindow.globalobject.wvdl_gDownloadedArray[i]);
		}
		
		if(bDelete)
		{
			setTimeout( hiddenWindow.globalobject.deletefile, 1000);	
		}
		
		hiddenWindow.globalobject.wvdl_gDownloadedArray = tempArray;
		UpdateView(CONST_DOWNLOADED);
		PreviewFile();
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doDownloadedDeleteall()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloaded');
		
		while(hiddenWindow.globalobject.wvdl_gDownloadedArray.length)	
		{
			hiddenWindow.globalobject.wvdl_gDownloadedArray.pop();    
		}
		UpdateView(CONST_DOWNLOADED);

	}
	catch(e)
	{
		debug_alert(e);
	}
}




function doDownloadedProperties()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloaded');
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadedArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				window.openDialog("chrome://webvideodownloader/content/downloadedproperty.xul","_blank","chrome,resizable,width=500,height=200,centerscreen",hiddenWindow.globalobject.wvdl_gDownloadedArray[i]);
			}
		}	
	}
	catch(e)
	{
		debug_alert(e);
	}	
		
}


function doDownloadedDownloadagain()
{
	try
	{
		ShowPlayer(false);
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloaded');
		
		var downloadArray = new Array();
		var reDownloadArray = new Array();
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadedArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				file.QueryInterface(Components.interfaces.nsIFile);
				
				var strPathName = hiddenWindow.globalobject.wvdl_gDownloadedArray[i].savepath + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].name;
				if(hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname)
					strPathName += "." + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname;
					
				file.initWithPath( strPathName );	
				if(file.exists())
				{
					if(!file.isDirectory())
					{
						if(MessageBoxYesNo(dynamic_setting_downloadagain, 0, window) != 1)
						{
							return 0;
						}
						break;
					}
				}
			}
		}
		
		
		var checkArray = new Array();
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{
			checkArray.push(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
		}
				
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadedArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				file.QueryInterface(Components.interfaces.nsIFile);
				
				/*
				var strPathName = hiddenWindow.globalobject.wvdl_gDownloadedArray[i].savepath + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].name;
				if(hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname)
					strPathName += "." + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname;
				*/
				
				var strName = CreateDownloadingFileName( checkArray, hiddenWindow.globalobject.wvdl_gDownloadedArray[i].savepath, hiddenWindow.globalobject.wvdl_gDownloadedArray[i].name, hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname);
				
				reDownloadArray.push(hiddenWindow.globalobject.wvdl_gDownloadedArray[i]);
				reDownloadArray[reDownloadArray.length-1].name = strName;
				checkArray.push(reDownloadArray[reDownloadArray.length-1]);
			}
			else
				downloadArray.push(hiddenWindow.globalobject.wvdl_gDownloadedArray[i]);
		}	
		
		hiddenWindow.globalobject.wvdl_gDownloadedArray = downloadArray;
		UpdateView(CONST_DOWNLOADED);
		
		
		for(var i=0;i<reDownloadArray.length;i++)
		{
			hiddenWindow.globalobject.wvdl_gDownloadingArray.unshift(new hiddenWindow.globalobject.wvdl_downloadingobj(
			reDownloadArray[i].url,
			reDownloadArray[i].size,
			(new Date()).getTime(),
			reDownloadArray[i].name,
			reDownloadArray[i].exname,
			reDownloadArray[i].savepath, 1));
			hiddenWindow.globalobject.StartDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[0]);
		}
		PreviewFile();
		UpdateView(CONST_DOWNLOADING);
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function CreateDownloadingFileName( checkArray, path, name, exname)
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
		
		var number = "";
		var strCurFileName = "";
		
		while(true)
		{
			strCurFileName = path + name;
			if(number)
			{
				strCurFileName += "(" + number + ")";
			}
			
			if(exname)
				strCurFileName += "." + exname;
				
			//debug_alert(strCurFileName);
		
			var homology = false;
			for(var i = 0;i < checkArray.length;i++)
			{
				var strPathName = checkArray[i].savepath + checkArray[i].name;
				if(checkArray[i].exname)
					strPathName += "." + checkArray[i].exname;
				
				if(strCurFileName == strPathName)
				{
					if(number == "")
						number = 1;
					else
						number++;
					//number = TestFile(checkArray[i].savepath,checkArray[i].name, checkArray[i].exname, number);
					strCurFileName = path + name + "(" + number + ")";
					if(exname)
						strCurFileName += "." + exname;
			
					homology = true;
				}
			}
			if(!homology)
				break;
		}
		
		if(number)
			return name + "(" + number + ")";
		else
			return name;
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function TestFile(inBasePath, strFlieName, strEx, number)
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
	         	.getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	         	
		var strBasePath = inBasePath;
		
		if(hiddenWindow.globalobject.wvdl_gCurSystem > 1)
		{
			if(strBasePath.substr(strBasePath.length-1,strBasePath.length-1) != "/")
				strBasePath+= "/";
		}
		else
		{
			if(strBasePath.substr(strBasePath.length-1,strBasePath.length-1) != "\\")
				strBasePath+= "\\";
		}
		
		var newPathFileName;
		var newFileName;
		var i = number;
		for(;i < 10000;i++)
		{
		    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			file.QueryInterface(Components.interfaces.nsIFile);
			if(i==0)
			{
				newPathFileName = strBasePath + strFlieName + "." + strEx;
				newFileName = strFlieName;
			}
			else
			{
				newFileName = strFlieName + "("+i+")";
				newPathFileName = strBasePath + strFlieName + "("+i+")" + "." + strEx;	
			}
			file.initWithPath( newPathFileName );
			if(file.exists())
			{
				if(file.isFile())
					continue;
			}
		    //file.create(0,0644);
			break;
		}
		
		return i;
	}
	catch(e)
	{
		debug_alert(e);
	}
	

}




function doDownloadedRename()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloaded');
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadedArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{	
			
				var tempFile = hiddenWindow.globalobject.wvdl_gDownloadedArray[i].savepath + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].name;
				if(hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname.length != 0)
					tempFile += "." + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname;
					
				var file = hiddenWindow.globalobject.FileFactory(tempFile);
				if(file.exists() && file.isFile())
				{
					if(idPreview != null)
					{
						clearTimeout(idPreview);
						idPreview = null;
					}
					
					ShowPlayer(false);
					window.openDialog("chrome://webvideodownloader/content/dlgrename.xul","_blank","chrome,resizable,width=500,height=200,centerscreen,modal",hiddenWindow.globalobject.wvdl_gDownloadedArray[i]);					
				}
				else
				{
					alert(dynamic_message_notfound);
				}
			
				
				break;
			}
		}	
	}
	catch(e)
	{
		debug_alert(e);
	}	
}


function doDownloadedOpenfile()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
        
        var tree = document.getElementById('idDownloaded'); 	
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadedArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				if(idPreview != null)
				{
					clearTimeout(idPreview);
					idPreview = null;
				}
				ShowPlayer(false);
				var name = hiddenWindow.globalobject.wvdl_gDownloadedArray[i].savepath + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].name;
				if(hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname.length)
					name += "." + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname;
				var file = GetFileObj(name);
				if(file)
					file.launch();
				else
					alert(dynamic_message_notfound);
				break;
			}
		}
				
	}
	catch(e)
	{
		debug_alert(e);
	}
		
}



function doDownloadedOpendirectory()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloaded');
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadedArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				var name = hiddenWindow.globalobject.wvdl_gDownloadedArray[i].savepath + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].name;
				if(hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname.length)
					name += "." + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname;
			
				var file = GetFileObj(name);	
				if(file)
					file.reveal();
				else
					debug_alert(dynamic_message_notfound);
			}
		}		
	}
	catch(e)
	{
		debug_alert(e);
	}
		
}




function GetFileObj(strPathFileName)
{
	try
	{	
		var file = FileFactory(strPathFileName);
		/*
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		file.QueryInterface(Components.interfaces.nsIFile);
		file.initWithPath( strPathFileName );
		*/
		if(file.exists())
		{
			return file;
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
	return null;
}


function OnSelectCaptureHistoryTree()
{
	try
	{	
		
	}
	catch(e)
	{
		debug_alert(e);
	}

}


function OnSelectDownloadingTree()
{

}


function OnSelectDownloadedTree()
{
	try
	{	
		if(idPreview != null)
		{
			clearTimeout(idPreview);
			idPreview = null;
		}
		idPreview = setTimeout( PreviewFile, 1000);
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function PreviewFile()
{
	try
	{		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		/*
		if(hiddenWindow.globalobject.wvdl_gCurSystem == 2)
		{
			ShowPlayer(false);
			return ;
		}
		*/
		
		var tree = document.getElementById('idDownloaded');
		
		if(hiddenWindow.globalobject.wvdl_gDownloadedArray.length == 0)
		{
			ShowPlayer(false);
			return ;
		}
		
		var bPreview = false;
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadedArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				var tempFile = hiddenWindow.globalobject.wvdl_gDownloadedArray[i].savepath + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].name;
				if(hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname.length != 0)
					tempFile += "." + hiddenWindow.globalobject.wvdl_gDownloadedArray[i].exname;
				
				//if(!CheckFLVHeader(tempFile))
					//continue;
				
				var flvplayer = document.getElementById("flvplayer");
		 		var embed = flvplayer.cloneNode("flvplayer");
		 		
		 		var strPath = "chrome://webvideodownloader/skin/flvplayer.swf?flv=" + tempFile;
		 		//debug_alert(strPath);
		 		embed.setAttribute("src", strPath);
		 		
		 		var height = getPreference("SothinkWebVideoDownloader", "WebVideoDownloader.FlvPalyHeight", 240);
		 		if(height != null && (height > 0 && height < 2048))
		 			embed.setAttribute("height", height);
		 		else
		 			embed.setAttribute("height", 240);
		 			
		 		var aBox = document.getElementById("flashplayerbox");
		 		aBox.removeChild(flvplayer);
		 		aBox.appendChild(embed);
				
				ShowPlayer(true);		
				bPreview = true;
				break;
			}
		}	
		if(!bPreview)
			ShowPlayer(false);
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function isSelectClassItme()
{
	try
	{
		var start = new Object();
		var end = new Object();
		var tree = document.getElementById("idClassTree");
		var numRanges = tree.view.selection.getRangeCount();
		
		for (var t = 0; t < numRanges; t++)
		{
		  tree.view.selection.getRangeAt(t,start,end);
		  for (var v = start.value; v <= end.value; v++)
		  {
		  	if(v == CONST_ALLDOWNLOADS)
				return true;
		  }
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
	return false;
}



function showpopTreeMenuCaptureHistory(event)
{

/*
		SetSwfMenuItemText();
		var _CurSelection = _getCurSelection();
		if(_CurSelection.length<=0 ||(_CurSelection.length>0 && _CurSelection[0].url==null)){
			window.document.getElementById("cmd_Saveas").setAttribute("disabled","true");
			window.document.getElementById("cmd_viewLocation").setAttribute("disabled","true");
			window.document.getElementById("cmd_Preview").setAttribute("disabled","true");
			window.document.getElementById("cmd_Property").setAttribute("disabled","true");
		}
		else{
			window.document.getElementById("cmd_Saveas").setAttribute("disabled","false");
			window.document.getElementById("cmd_viewLocation").setAttribute("disabled","false");
			window.document.getElementById("cmd_Preview").setAttribute("disabled","false");
			window.document.getElementById("cmd_Property").setAttribute("disabled","false");
		}

*/

	try
	{
		window.document.getElementById("cmd_capturehistory_save").setAttribute("disabled","true");
		window.document.getElementById("cmd_capturehistory_saveall").setAttribute("disabled","true");
		window.document.getElementById("cmd_capturehistory_delete").setAttribute("disabled","true");
		window.document.getElementById("cmd_capturehistory_deleteall").setAttribute("disabled","true");
		window.document.getElementById("cmd_capturehistory_properties").setAttribute("disabled","true");			
	
		if(isSelectClassItme())
		{
			return ;		
		}
	
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idCaptureHistory');
		
		var nCount = 0;
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gHistoryArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
				nCount++;
		}
		
		
		if(hiddenWindow.globalobject.wvdl_gHistoryArray.length > 0)	
		{
			window.document.getElementById("cmd_capturehistory_deleteall").setAttribute("disabled","false");
		}
		
		if(hiddenWindow.globalobject.wvdl_gHistoryArray.length >= 2)	
		{
			window.document.getElementById("cmd_capturehistory_saveall").setAttribute("disabled","false");
		}
		
		if(nCount == 1)	
		{
			window.document.getElementById("cmd_capturehistory_save").setAttribute("disabled","false");
			//window.document.getElementById("cmd_capturehistory_saveall").setAttribute("disabled","false");
			window.document.getElementById("cmd_capturehistory_delete").setAttribute("disabled","false");
			window.document.getElementById("cmd_capturehistory_deleteall").setAttribute("disabled","false");
			window.document.getElementById("cmd_capturehistory_properties").setAttribute("disabled","false");			
		}
		
		if(nCount > 1)	
		{
			window.document.getElementById("cmd_capturehistory_save").setAttribute("disabled","false");
			window.document.getElementById("cmd_capturehistory_saveall").setAttribute("disabled","false");
			window.document.getElementById("cmd_capturehistory_delete").setAttribute("disabled","false");
			window.document.getElementById("cmd_capturehistory_deleteall").setAttribute("disabled","false");
			window.document.getElementById("cmd_capturehistory_properties").setAttribute("disabled","false");			
		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function showpopTreeMenuDownloading(event)
{
	try
	{
		window.document.getElementById("cmd_downloading_start").setAttribute("disabled","true");
		window.document.getElementById("cmd_downloading_stop").setAttribute("disabled","true");
		window.document.getElementById("cmd_downloading_startall").setAttribute("disabled","true");
		window.document.getElementById("cmd_downloading_stopall").setAttribute("disabled","true");
		window.document.getElementById("cmd_downloading_delete").setAttribute("disabled","true");			
		window.document.getElementById("cmd_downloading_deleteall").setAttribute("disabled","true");			
		window.document.getElementById("cmd_downloading_properties").setAttribute("disabled","true");			
		
		if(isSelectClassItme())
		{
			return ;		
		}
		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloading');
		
		var tempArray = new Array();
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
				tempArray.push(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
		}
		
		if(hiddenWindow.globalobject.wvdl_gDownloadingArray.length > 1)
		{
			window.document.getElementById("cmd_downloading_startall").setAttribute("disabled","false");
			window.document.getElementById("cmd_downloading_stopall").setAttribute("disabled","false");
			window.document.getElementById("cmd_downloading_deleteall").setAttribute("disabled","false");			
		}	
	
		if(tempArray.length == 1)	
		{
			window.document.getElementById("cmd_downloading_properties").setAttribute("disabled","false");				
			window.document.getElementById("cmd_downloading_delete").setAttribute("disabled","false");				
			window.document.getElementById("cmd_downloading_deleteall").setAttribute("disabled","false");				
			if(tempArray[0].state == hiddenWindow.globalobject.ITEM_STATE_DOWNLOADING)
			{
				window.document.getElementById("cmd_downloading_start").setAttribute("disabled","true");
				window.document.getElementById("cmd_downloading_stop").setAttribute("disabled","false");
			}
			else
			{
				window.document.getElementById("cmd_downloading_start").setAttribute("disabled","false");
				window.document.getElementById("cmd_downloading_stop").setAttribute("disabled","true");
			}			
		}
		
		if(tempArray.length > 1)	
		{
			var nDownloading = 0;
			for(var i = 0;i < tempArray.length; i++)
			{
				if(tempArray[i].state == hiddenWindow.globalobject.ITEM_STATE_DOWNLOADING)
				{
					nDownloading++;
				}
			}
			
			window.document.getElementById("cmd_downloading_properties").setAttribute("disabled","false");			
			window.document.getElementById("cmd_downloading_delete").setAttribute("disabled","false");
			window.document.getElementById("cmd_downloading_deleteall").setAttribute("disabled","false");
			
			if(nDownloading == tempArray.length)
			{
				window.document.getElementById("cmd_downloading_start").setAttribute("disabled","true");
				window.document.getElementById("cmd_downloading_startall").setAttribute("disabled","true");
				
				window.document.getElementById("cmd_downloading_stop").setAttribute("disabled","false");
				window.document.getElementById("cmd_downloading_stopall").setAttribute("disabled","false");	
			}
			else
			{
				window.document.getElementById("cmd_downloading_start").setAttribute("disabled","false");
				window.document.getElementById("cmd_downloading_startall").setAttribute("disabled","false");
				
				window.document.getElementById("cmd_downloading_stop").setAttribute("disabled","true");
				window.document.getElementById("cmd_downloading_stopall").setAttribute("disabled","true");	
			}		
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function showpopTreeMenuDownloaded(event)
{	
	try
	{
	
		window.document.getElementById("cmd_downloaded_delete").setAttribute("disabled","true");
		//window.document.getElementById("cmd_downloaded_deleteall").setAttribute("disabled","true");
		window.document.getElementById("cmd_downloaded_openfile").setAttribute("disabled","true");
		window.document.getElementById("cmd_downloaded_opendirectory").setAttribute("disabled","true");
		window.document.getElementById("cmd_downloaded_properties").setAttribute("disabled","true");			
		
		window.document.getElementById("cmd_downloaded_downloadagain").setAttribute("disabled","true");			
		window.document.getElementById("cmd_downloaded_rename").setAttribute("disabled","true");			
		
		
		if(isSelectClassItme())
		{
			return ;		
		}
		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloaded');
		
		var tempArray = new Array();
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadedArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
				tempArray.push(hiddenWindow.globalobject.wvdl_gDownloadedArray[i]);
		}
		
		
		/*
		if(hiddenWindow.globalobject.wvdl_gDownloadedArray.length > 0)
		{
			window.document.getElementById("cmd_downloaded_deleteall").setAttribute("disabled","false");
		}
		*/
		
		if(tempArray.length > 0)
		{
			window.document.getElementById("cmd_downloaded_delete").setAttribute("disabled","false");
			//window.document.getElementById("cmd_downloaded_deleteall").setAttribute("disabled","false");
			window.document.getElementById("cmd_downloaded_openfile").setAttribute("disabled","false");
			window.document.getElementById("cmd_downloaded_opendirectory").setAttribute("disabled","false");
			window.document.getElementById("cmd_downloaded_properties").setAttribute("disabled","false");	
			window.document.getElementById("cmd_downloaded_downloadagain").setAttribute("disabled","false");			
			if(tempArray.length == 1)
				window.document.getElementById("cmd_downloaded_rename").setAttribute("disabled","false");							
		}
			
		if(hiddenWindow.globalobject.wvdl_gCurSystem == 2)
		{
			document.getElementById( "wnd_menu_downloaded_openfile" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_downloaded_opendirectory" ).setAttribute("hidden", "true");	
			document.getElementById( "wnd_menu_downloaded_menuseparator1" ).setAttribute("hidden", "true");		
		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function OnKDelete()
{
	try
	{
		if(document.getElementById("idCaptureHistory").hidden == false)
		{
			return doCaptureHistoryDelete();		
		}
		
		if(document.getElementById("idDownloading").hidden == false)
		{
			return doDownloadingDelete();
		}
		
		if(document.getElementById("idDownloaded").hidden == false)
		{
			return doDownloadedDelete();
		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function OnDbClickCaptureHistoryTree(event)
{
	try
	{
		if(event.button != 0)
			return ;
			
		doCaptureHistorySave();	
			
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function OnDbClickDownloadingTree(event)
{
	try
	{
		if(event.button != 0)
			return ;
		
		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idDownloading');
		
		var nCount = 0;
		var bAlldownloading = true;
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				nCount++;
				if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state != hiddenWindow.globalobject.ITEM_STATE_DOWNLOADING)
					bAlldownloading = false;
			}
		}
		
		for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
		{
			if(tree.view.selection.isSelected(i))
			{
				if(nCount == 1)
				{
					if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state == hiddenWindow.globalobject.ITEM_STATE_DOWNLOADING)
						hiddenWindow.globalobject.StopDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
					else
						hiddenWindow.globalobject.ContinueDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
						
					break;	
				}
				
				if(bAlldownloading)
				{
					hiddenWindow.globalobject.StopDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
				}
				else
				{
					if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].state != hiddenWindow.globalobject.ITEM_STATE_DOWNLOADING)
						hiddenWindow.globalobject.ContinueDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[i]);
				}	
			}
		}
		
		UpdateView(CONST_DOWNLOADING);
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function OnDbClickDownloadedTree(event)
{
	try
	{
		if(event.button != 0)
			return ;
	
		doDownloadedOpenfile();
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function CheckFLVHeader(filepathname)
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
         
		var inFile = hiddenWindow.globalobject.FileFactory(filepathname);
		if(inFile.exists() && inFile.isFile())
		{
			if(inFile.fileSize < 8)
				return false;
			
			var inStream = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
			inStream.init( inFile, 1, 0, false);
			var inBinaryStream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
			inBinaryStream.setInputStream(inStream);	
			var pBuf = inBinaryStream.readBytes(3);
			
			if (pBuf[0] != 'F' || pBuf[1] != 'L' || pBuf[2] != 'V')
				return false;
			
			pBuf = inBinaryStream.read8();			
			if (pBuf != 1)
				return false;
			
			/*
			pBuf = inBinaryStream.read8();			
			var r = (pBuf & 0xfa); // reserved bits (2, 4, 5, 6, 7, 8) must be 0
			if (r != 0)
				return false;
			
			pBuf = inBinaryStream.read32();	
			if(pBuf != 9)
				return false;	
			*/
				
			inBinaryStream.close();		
			inStream.close();
			return true;	
		}
		else
		{
			return false;
		}	
	}
	catch(e)
	{
		debug_alert(e);
		return false;
	}
}


function onPopupWndMenuFile(event)
{
	try
	{
		var start = new Object();
		var end = new Object();
		var tree = document.getElementById("idClassTree");
		var numRanges = tree.view.selection.getRangeCount();
		
		var index = 0;
		for (var t = 0; t < numRanges; t++)
		{
		  tree.view.selection.getRangeAt(t,start,end);
		  for (var v = start.value; v <= end.value; v++)
		  {
		  	index = v;
		  	break;
		  }
		}
		
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
			
			
		if(index == 0)
		{
			document.getElementById( "wnd_menu_file_item1" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item2" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item3" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item4" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item17" ).setAttribute("hidden", "true");		
			
			document.getElementById( "wnd_menu_file_item5" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item6" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item7" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item8" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item9" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item10" ).setAttribute("hidden", "true");	
				
			document.getElementById( "wnd_menu_file_item11" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item12" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item13" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item14" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item15" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item16" ).setAttribute("hidden", "true");	
			
			document.getElementById( "wnd_menu_file_menuseparator" ).setAttribute("hidden", "true");	
					
			return ;
		}
		
		if(index == 1)
		{
			document.getElementById( "wnd_menu_file_item1" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item2" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item3" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item4" ).setAttribute("hidden", "false");
			document.getElementById( "wnd_menu_file_item17" ).setAttribute("hidden", "false");				
			
			document.getElementById( "wnd_menu_file_item5" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item6" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item7" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item8" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item9" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item10" ).setAttribute("hidden", "true");	
				
			document.getElementById( "wnd_menu_file_item11" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item12" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item13" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item14" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item15" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item16" ).setAttribute("hidden", "true");
			
			document.getElementById( "wnd_menu_file_menuseparator" ).setAttribute("hidden", "false");
			showpopTreeMenuCaptureHistory();
			return ;
		}
		
		if(index == 2)
		{
			document.getElementById( "wnd_menu_file_item1" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item2" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item3" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item4" ).setAttribute("hidden", "true");
			document.getElementById( "wnd_menu_file_item17" ).setAttribute("hidden", "true");				
			
			document.getElementById( "wnd_menu_file_item5" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item6" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item7" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item8" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item9" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item10" ).setAttribute("hidden", "false");	
				
			document.getElementById( "wnd_menu_file_item11" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item12" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item13" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item14" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item15" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item16" ).setAttribute("hidden", "true");
			
			document.getElementById( "wnd_menu_file_menuseparator" ).setAttribute("hidden", "false");
			
			showpopTreeMenuDownloading();
			return ;
		}
		
		if(index == 3)
		{
			document.getElementById( "wnd_menu_file_item1" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item2" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item3" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item4" ).setAttribute("hidden", "true");
			document.getElementById( "wnd_menu_file_item17" ).setAttribute("hidden", "true");				
			
			document.getElementById( "wnd_menu_file_item5" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item6" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item7" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item8" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item9" ).setAttribute("hidden", "true");		
			document.getElementById( "wnd_menu_file_item10" ).setAttribute("hidden", "true");	
			
			if(hiddenWindow.globalobject.wvdl_gCurSystem == 2)
			{	
				document.getElementById( "wnd_menu_file_item11" ).setAttribute("hidden", "true");		
				document.getElementById( "wnd_menu_file_item12" ).setAttribute("hidden", "true");		
			}
			else
			{	
				document.getElementById( "wnd_menu_file_item11" ).setAttribute("hidden", "false");		
				document.getElementById( "wnd_menu_file_item12" ).setAttribute("hidden", "false");		
			}
			document.getElementById( "wnd_menu_file_item13" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item14" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item15" ).setAttribute("hidden", "false");		
			document.getElementById( "wnd_menu_file_item16" ).setAttribute("hidden", "false");
			
			document.getElementById( "wnd_menu_file_menuseparator" ).setAttribute("hidden", "false");
			showpopTreeMenuDownloaded();
			return ;
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doCloseWnd()
{
	try
	{
		doBarShowMainWindow();
	}
	catch(e)
	{
		debug_alert(e);
	}
	
}


function onPopupWndMenuOptions(event)
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
		
		
		//document.getElementById( "wnd_menu_options_notification" ).setAttribute( "checked", hiddenWindow.globalobject.wvdl_gInterceptiontip);		
		//document.getElementById( "wnd_menu_options_showdownloadmanager" ).setAttribute( "checked", true);
		//document.getElementById( "wnd_menu_options_showtoolbarbutton" ).setAttribute( "checked", hiddenWindow.globalobject.wvdl_gShowBarButton);

		var start = new Object();
		var end = new Object();
		var tree = document.getElementById("idClassTree");
		var numRanges = tree.view.selection.getRangeCount();
		
		var index = 0;
		for (var t = 0; t < numRanges; t++)
		{
		  tree.view.selection.getRangeAt(t,start,end);
		  for (var v = start.value; v <= end.value; v++)
		  {
		  	index = v;
		  	break;
		  }
		}
		
	
		if(index == 0)
		{
			//window.document.getElementById("wnd_menu_options_resetcolumns").setAttribute("disabled","true");
			document.getElementById("cmd_resetcolumns").setAttribute("disabled","true");
		}
		else
		{
			//window.document.getElementById("wnd_menu_options_resetcolumns").setAttribute("disabled","false");
			document.getElementById("cmd_resetcolumns").setAttribute("disabled","false");
		}

	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doBarVideocapturenotification()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
         
		hiddenWindow.globalobject.wvdl_gInterceptiontip = !hiddenWindow.globalobject.wvdl_gInterceptiontip;
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doBarShowMainWindow()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
         
        hiddenWindow.globalobject.wvdl_gDownloadManageDisplay = false;
		window.close();
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


/*
function doBarShowButton()
{
	try
	{	
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
        
		hiddenWindow.globalobject.ShowBarButton(!hiddenWindow.globalobject.wvdl_gShowBarButton);
	}
	catch(e)
	{
		debug_alert(e);
	}
}
*/


function doBarResetcolumns()
{
	try
	{	
		var start = new Object();
		var end = new Object();
		var tree = document.getElementById("idClassTree");
		var numRanges = tree.view.selection.getRangeCount();
		
		var index = 0;
		for (var t = 0; t < numRanges; t++)
		{
		  tree.view.selection.getRangeAt(t,start,end);
		  for (var v = start.value; v <= end.value; v++)
		  {
		  	index = v;
		  	break;
		  }
		}
		
		if(index == 1)
		{
			document.getElementById("capturehistory_url").setAttribute("width", 400);
			document.getElementById("capturehistory_size").setAttribute("width", 80);
			document.getElementById("capturehistory_capturedate").setAttribute("width", 140);
			//document.getElementById("capturehistory_status").setAttribute("width", 100);
			
			
			document.getElementById("capturehistory_url").setAttribute("hidden", false);
			document.getElementById("capturehistory_size").setAttribute("hidden", false);
			document.getElementById("capturehistory_capturedate").setAttribute("hidden", false);
			//document.getElementById("capturehistory_status").setAttribute("hidden", false);
		
		}

		if(index == 2)
		{
			document.getElementById("downloading_name").setAttribute("width", 140);
			document.getElementById("downloading_size").setAttribute("width", 80);
			document.getElementById("downloading_completed").setAttribute("width", 80);
			document.getElementById("downloading_progress").setAttribute("width", 100);
			document.getElementById("downloading_speed").setAttribute("width", 80);
			document.getElementById("downloading_elapsed").setAttribute("width", 80);
			document.getElementById("downloading_timeleft").setAttribute("width", 80);
			document.getElementById("downloading_status").setAttribute("width", 80);
			document.getElementById("downloading_url").setAttribute("width", 300);
			
			document.getElementById("downloading_name").setAttribute("hidden", false);
			document.getElementById("downloading_size").setAttribute("hidden", false);
			document.getElementById("downloading_completed").setAttribute("hidden", false);
			document.getElementById("downloading_progress").setAttribute("hidden", false);
			document.getElementById("downloading_speed").setAttribute("hidden", false);
			document.getElementById("downloading_elapsed").setAttribute("hidden", false);
			document.getElementById("downloading_timeleft").setAttribute("hidden", false);
			document.getElementById("downloading_status").setAttribute("hidden", false);
			document.getElementById("downloading_url").setAttribute("hidden", true);
			
			
		
		}
		
		if(index == 3)
		{
			document.getElementById("downloaded_name").setAttribute("width", 160);
			document.getElementById("downloaded_size").setAttribute("width", 80);
			document.getElementById("downloaded_timecompleted").setAttribute("width", 140);
			document.getElementById("downloaded_savepath").setAttribute("width", 300);
			document.getElementById("downloaded_status").setAttribute("width", 80);
			document.getElementById("downloaded_url").setAttribute("width", 300);
			
			document.getElementById("downloaded_name").setAttribute("hidden", false);
			document.getElementById("downloaded_size").setAttribute("hidden", false);
			document.getElementById("downloaded_timecompleted").setAttribute("hidden", false);
			document.getElementById("downloaded_savepath").setAttribute("hidden", true);
			document.getElementById("downloaded_status").setAttribute("hidden", false);
			document.getElementById("downloaded_url").setAttribute("hidden", true);
			
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function onPopupWndMenuHelp()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doHelp()
{
	try
	{
		var topWindow = getTopWindow();
		if(topWindow)
		{
			var web = topWindow.document.getElementById("content");
			var Url = dynamic_domainname + "/tutorials.php";
			web.selectedTab = web.addTab(Url);
			web.getBrowserForTab(web.selectedTab);
		}
	}
	catch(e)
	{
		debug_alert(e);
	}
}



function doBarViewtop10()
{
	try
	{	
		var topWindow = getTopWindow();
		var web = topWindow.document.getElementById("content");
		var Url = dynamic_domainname;
		if(dynamic_runlanguage == "zh-CN")
		 	Url += "/rank.php";
		else
		 	Url += "/topvideo";
		web.selectedTab = web.addTab(Url);
		web.getBrowserForTab(web.selectedTab);
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doBarVisithomepage()
{
	try
	{	
		var topWindow = getTopWindow();
		if(topWindow)
		{
			var web = topWindow.document.getElementById("content");
			var Url = dynamic_domainname;
			web.selectedTab = web.addTab(Url);
			web.getBrowserForTab(web.selectedTab);
		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function doAbout()
{
	try
	{	
		window.openDialog("chrome://webvideodownloader/content/about.xul","_blank","chrome,centerscreen");
	}
	catch(e)
	{
		debug_alert(e);
	}
}

function getTopWindow()
{
	try
	{
		var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
		var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
		var topWindow = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
	
		if( !topWindow )
		{
			return null;
			//topWindow = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
		}
	
		return topWindow;
	}
	catch(e)
	{
		debug_alert(e);
	}
}


function ShowDownloadingItem(item)
{
	try
	{
		var tree = document.getElementById("idClassTree");
		tree.view.selection.select(2);
		
		tree = document.getElementById('idDownloading');
		tree.view.selection.select(item);
		tree.focus();
	}
	catch(e)
	{
		debug_alert(e);
	}
}


