var curSel = new Array();     
const highlightCSS = "chrome://firebug/content/highlighter.css";

function oninitialize()
{	
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         	.getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;		
		hiddenWindow.globalobject.wvdl_gViewSidebar = true;
		
		var hidden_swf_name = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.SwfName", false);
		var hidden_swf_size = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.SwfSize", false);
		//var hidden_swf_state = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.SwfState", false);
		var hidden_swf_url = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.SwfUrl", true);

		document.getElementById("swf_name").setAttribute("hidden", hidden_swf_name);
		document.getElementById("swf_size").setAttribute("hidden", hidden_swf_size);
		//document.getElementById("swf_state").setAttribute("hidden", hidden_swf_state);
		document.getElementById("swf_url").setAttribute("hidden", hidden_swf_url);
		
		
		var width_swf_name = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.SwfName", 60);
		var width_swf_size = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.SwfSize", 40);
		//var width_swf_state = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.SwfState", 40);
		var width_swf_url = getPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.SwfUrl", 200);

		document.getElementById("swf_name").setAttribute("width", width_swf_name);
		document.getElementById("swf_size").setAttribute("width", width_swf_size);
		//document.getElementById("swf_state").setAttribute("width", width_swf_state);
		document.getElementById("swf_url").setAttribute("width", width_swf_url);
				
		hookPanelListeners();
		doSidebarWebParse();
	}
	catch(e)
	{
		debug_alert(e);
	}

}


function onclosewindow()
{
	try
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         	.getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;		
         	
		hiddenWindow.globalobject.wvdl_gViewSidebar = false;
		
		unhookPanelListeners();
		
		var width_swf_name = document.getElementById("swf_name").getAttribute("width");
		var width_swf_size = document.getElementById("swf_size").getAttribute("width");
		//var width_swf_state = document.getElementById("swf_state").getAttribute("width");
		var width_swf_url = document.getElementById("swf_url").getAttribute("width");
		
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.SwfName", width_swf_name);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.SwfSize", width_swf_size);
		//setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.SwfState", width_swf_state);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Width.SwfUrl", width_swf_url);
		
		var hidden_swf_name = document.getElementById("swf_name").getAttribute("hidden");
		var hidden_swf_size = document.getElementById("swf_size").getAttribute("hidden");
		//var hidden_swf_state = document.getElementById("swf_state").getAttribute("hidden");
		var hidden_swf_url = document.getElementById("swf_url").getAttribute("hidden");
				
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.SwfName", hidden_swf_name);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.SwfSize", hidden_swf_size);
		//setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.SwfState", hidden_swf_state);
		setPreference( "SothinkWebVideoDownloader", "WebVideoDownloader.Hidden.SwfUrl", hidden_swf_url);
	
	}
	catch(e)
	{
		debug_alert(e);
	}

}




function onclickRegisterTip(event)
{
	try
	{
		if(event.button == 0)
		{
			doSidebarRegister();
		}
	}
	catch(e)
	{
		debug_alert(e);
	}

}




function getCurSWFTreeSelection()
{
	while(curSel.length)
	{
	 	curSel.pop();         
	}

	var tree=document.getElementById('idSwfTree');
	for(var i=0;i<gSwfArray.length;i++)
	{
		if(tree.view.selection.isSelected(i))
		{
			curSel.push(gSwfArray[i]);		
		}
	}
}


function doSidebarWebParse()
{
	try
	{
		doWebParse();
		
		//if(validateURLs.length==0)
		//	alert("No Flash movie found on current Page.");
		
	}
	catch(e)
	{
		debug_alert(e);
	}
  
}



function doSidebarViewlocation()
{
	try
	{
		getCurSWFTreeSelection();
		
		if(curSel.length == 0)
		{
			alert(dynamic_rightmenucmds_pleaseselectfile);
			return ;
		}
		
		if(curSel[0].url != null)
		{
			initWeb();  
			docs = webdeveloper_getDocuments(window.parent.content, new Array());
			for (j = 0; j < docs.length; j++)
			{
				var x=docs[j];
			
				var embeds=x.getElementsByTagName("embed");   				  
				for(var i=0;i<embeds.length;i++)
				{
					if(window.parent.makeURLAbsolute(docs[j].baseURI, embeds[i].src)==curSel[0].url)
					{
						embeds[i].scrollIntoView(true);
						return;
					}
				}
	
				var links=x.getElementsByTagName("a");   			  		            
	
				for(var i=0;i<links.length;i++)
				{
					if(window.parent.makeURLAbsolute(docs[j].baseURI, links[i].href)==curSel[0].url)
					{ 
						links[i].scrollIntoView(true);
						return;
					}
				}
			}
		}
		
	}
	catch(e)
	{
		debug_alert(e);
	}
}
	
	
	
function processRelativePath(pathRelative)
{
	var a =pathRelative;
	while(a.lastIndexOf("\\")>0)
	a=a.replace("\\","/");
	return a;
}
	
	
	
function doSidebarPreview()
{	
	getCurSWFTreeSelection();
	if(curSel.length)
	{
		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
         
		var topWindow = hiddenWindow.globalobject.getTopWindow();
		if(topWindow)
		{
			var web = topWindow.document.getElementById("content");
			
			for(var j=0;j<curSel.length;j++)
			{
				web.selectedTab = web.addTab(curSel[j].url);
			}
		}
	}
	else
	{
  		alert(dynamic_rightmenucmds_pleaseselectfile);
  	}
}
	

	
function doSidebarShowProperty()
{
	try
	{
		getCurSWFTreeSelection();
		if(curSel.length)
		{
			for(var j=0;j<curSel.length;j++)
			{
				window.openDialog("chrome://webvideodownloader/content/swfproperty.xul","_blank","chrome,resizable,width=500,height=200,centerscreen",curSel[j]);
			}
		}
		else
		{
	  		alert(dynamic_rightmenucmds_pleaseselectfile);
	  	}
	}
	catch(e)
	{
		debug_alert(e);
	}	
		
}	


function doSidebarSaveas()
{
	try
	{
		getCurSWFTreeSelection();
		if(curSel.length == 0)
		{
	  		alert(dynamic_rightmenucmds_pleaseselectfile);
	  		return ;
	  	}

		var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
	
		var tree = document.getElementById('idSwfTree');
		
		if(curSel.length == 1)
		{
			for(var i = 0;i < curSel.length;i++)
			{
				var saveitem = curSel[i];
				var saveparam = new OpenSaveDlgObj( saveitem.name, saveitem.filetype, hiddenWindow.globalobject.wvdl_gSavePath);
				if(!OpenSaveDlg(saveparam))
					return -1;
				
				for(var i = 0;i < hiddenWindow.globalobject.wvdl_gDownloadingArray.length;i++)
				{	
					var downloadingItem = hiddenWindow.globalobject.wvdl_gDownloadingArray[i].savepath + hiddenWindow.globalobject.wvdl_gDownloadingArray[i].name;
					if(hiddenWindow.globalobject.wvdl_gDownloadingArray[i].exname)
						downloadingItem += "." + hiddenWindow.globalobject.wvdl_gDownloadingArray[i].exname;
						
					if(saveparam.resultPathName == downloadingItem)
					{
						alert(dynamic_setting_createfileerror);
						return -1;
					}
				}
				
				hiddenWindow.globalobject.wvdl_gDownloadingArray.unshift(new hiddenWindow.globalobject.wvdl_downloadingobj(
				saveitem.url,
				saveitem.size,
				saveitem.date,
				saveparam.resultFileName,
				saveparam.resultExName,
				saveparam.resultPath, 1));
				
				hiddenWindow.globalobject.StartDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[0]);
				break;
			}			
		}
			
			
		if(curSel.length > 1)
		{
			var strSavePath = dobrowse();
		
			if(strSavePath != false)
			{
				if(hiddenWindow.globalobject.wvdl_gCurSystem > 1)
					strSavePath += "/"; 
				else
					strSavePath += "\\"; 
				
				for(var i = 0;i < curSel.length;i++)
				{
					
						var filename = ClearSpecialCharacter(curSel[i].name);
						var strResult = CreateOnlyFile(strSavePath, filename, curSel[i].filetype);
						
						hiddenWindow.globalobject.wvdl_gDownloadingArray.unshift(new hiddenWindow.globalobject.wvdl_downloadingobj(
						curSel[i].url,
						curSel[i].size,
						curSel[i].date,
						strResult,
						curSel[i].filetype,
						strSavePath, 1));
						
						hiddenWindow.globalobject.StartDownload(hiddenWindow.globalobject.wvdl_gDownloadingArray[0]);
				}
			}
		}
		
		
		ShowWVDLwnd();
		var wnd = GetWVDLwnd()
		if(wnd)
		{
			wnd.UpdateView(2);
		}
	}
	catch(e)
	{
		debug_alert(e);
	}

}





function GetWVDLwnd()
{	
	var inType = "SWVD:Manager";
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow(inType);
	
	if (topWindow)
		return topWindow;
	else
		return null;

}


function ShowWVDLwnd()
{
	try
	{		
		var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
		var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
		var topWindow = windowManagerInterface.getMostRecentWindow("SWVD:Manager");
		
		if (topWindow)
		  topWindow.focus();
		else
		  window.open( "chrome://webvideodownloader/content/webvideodownloadermainwnd.xul", "_blank", "chrome,dialog=no,resizable");
	
	}
	catch(e)
	{
		debug_alert(e);
	}    
}
